/**
 * Parse JavaScript SDK v1.9.1
 *
 * Copyright (c) 2015-present, Parse, LLC.
 * All rights reserved.
 *
 * The source tree of this library can be found at
 *   https://github.com/ParsePlatform/Parse-SDK-JS
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */
!function(e){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=e();else if("function"==typeof define&&define.amd)define([],e);else{var t;t="undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:this,t.Parse=e()}}(function(){return function e(t,r,n){function a(s,o){if(!r[s]){if(!t[s]){var u="function"==typeof require&&require;if(!o&&u)return u(s,!0);if(i)return i(s,!0);var l=new Error("Cannot find module '"+s+"'");throw l.code="MODULE_NOT_FOUND",l}var c=r[s]={exports:{}};t[s][0].call(c.exports,function(e){var r=t[s][1][e];return a(r?r:e)},c,c.exports,e,t,r,n)}return r[s].exports}for(var i="function"==typeof require&&require,s=0;s<n.length;s++)a(n[s]);return a}({1:[function(e,t,r){"use strict";function n(e,t,r){if(e=e||"",e=e.replace(/^\s*/,""),e=e.replace(/\s*$/,""),0===e.length)throw new TypeError("A name for the custom event must be provided");for(var n in t)if("string"!=typeof n||"string"!=typeof t[n])throw new TypeError('track() dimensions expects keys and values of type "string".');return r=r||{},s["default"].getAnalyticsController().track(e,t)._thenRunCallbacks(r)}var a=e("babel-runtime/helpers/interop-require-default")["default"];Object.defineProperty(r,"__esModule",{value:!0}),r.track=n;var i=e("./CoreManager"),s=a(i);s["default"].setAnalyticsController({track:function(e,t){var r=s["default"].getRESTController();return r.request("POST","events/"+e,{dimensions:t})}})},{"./CoreManager":3,"babel-runtime/helpers/interop-require-default":56}],2:[function(e,t,r){"use strict";function n(e,t,r){if(r=r||{},"string"!=typeof e||0===e.length)throw new TypeError("Cloud function name must be a string.");var n={};return r.useMasterKey&&(n.useMasterKey=r.useMasterKey),r.sessionToken&&(n.sessionToken=r.sessionToken),s["default"].getCloudController().run(e,t,n)._thenRunCallbacks(r)}var a=e("babel-runtime/helpers/interop-require-default")["default"];Object.defineProperty(r,"__esModule",{value:!0}),r.run=n;var i=e("./CoreManager"),s=a(i),o=e("./decode"),u=a(o),l=e("./encode"),c=a(l),f=e("./ParseError"),d=a(f),h=e("./ParsePromise"),p=a(h);s["default"].setCloudController({run:function(e,t,r){var n=s["default"].getRESTController(),a=(0,c["default"])(t,!0),i={};r.hasOwnProperty("useMasterKey")&&(i.useMasterKey=r.useMasterKey),r.hasOwnProperty("sessionToken")&&(i.sessionToken=r.sessionToken);var o=n.request("POST","functions/"+e,a,i);return o.then(function(e){var t=(0,u["default"])(e);return t&&t.hasOwnProperty("result")?p["default"].as(t.result):p["default"].error(new d["default"](d["default"].INVALID_JSON,"The server returned an invalid response."))})._thenRunCallbacks(r)}})},{"./CoreManager":3,"./ParseError":13,"./ParsePromise":20,"./decode":35,"./encode":36,"babel-runtime/helpers/interop-require-default":56}],3:[function(e,t,r){(function(e){"use strict";function r(e,t,r){t.forEach(function(t){if("function"!=typeof r[t])throw new Error(e+" must implement "+t+"()")})}var n={IS_NODE:"undefined"!=typeof e&&!!e.versions&&!!e.versions.node&&!e.versions.electron,REQUEST_ATTEMPT_LIMIT:5,SERVER_URL:"https://api.parse.com/1",LIVEQUERY_SERVER_URL:null,VERSION:"js1.9.1",APPLICATION_ID:null,JAVASCRIPT_KEY:null,MASTER_KEY:null,USE_MASTER_KEY:!1,PERFORM_USER_REWRITE:!0,FORCE_REVOCABLE_SESSION:!1};t.exports={get:function(e){if(n.hasOwnProperty(e))return n[e];throw new Error("Configuration key not found: "+e)},set:function(e,t){n[e]=t},setAnalyticsController:function(e){r("AnalyticsController",["track"],e),n.AnalyticsController=e},getAnalyticsController:function(){return n.AnalyticsController},setCloudController:function(e){r("CloudController",["run"],e),n.CloudController=e},getCloudController:function(){return n.CloudController},setConfigController:function(e){r("ConfigController",["current","get"],e),n.ConfigController=e},getConfigController:function(){return n.ConfigController},setFileController:function(e){r("FileController",["saveFile","saveBase64"],e),n.FileController=e},getFileController:function(){return n.FileController},setInstallationController:function(e){r("InstallationController",["currentInstallationId"],e),n.InstallationController=e},getInstallationController:function(){return n.InstallationController},setObjectController:function(e){r("ObjectController",["save","fetch","destroy"],e),n.ObjectController=e},getObjectController:function(){return n.ObjectController},setObjectStateController:function(e){r("ObjectStateController",["getState","initializeState","removeState","getServerData","setServerData","getPendingOps","setPendingOp","pushPendingState","popPendingState","mergeFirstPendingState","getObjectCache","estimateAttribute","estimateAttributes","commitServerChanges","enqueueTask","clearAllState"],e),n.ObjectStateController=e},getObjectStateController:function(){return n.ObjectStateController},setPushController:function(e){r("PushController",["send"],e),n.PushController=e},getPushController:function(){return n.PushController},setQueryController:function(e){r("QueryController",["find"],e),n.QueryController=e},getQueryController:function(){return n.QueryController},setRESTController:function(e){r("RESTController",["request","ajax"],e),n.RESTController=e},getRESTController:function(){return n.RESTController},setSessionController:function(e){r("SessionController",["getSession"],e),n.SessionController=e},getSessionController:function(){return n.SessionController},setStorageController:function(e){e.async?r("An async StorageController",["getItemAsync","setItemAsync","removeItemAsync"],e):r("A synchronous StorageController",["getItem","setItem","removeItem"],e),n.StorageController=e},getStorageController:function(){return n.StorageController},setUserController:function(e){r("UserController",["setCurrentUser","currentUser","currentUserAsync","signUp","logIn","become","logOut","requestPasswordReset","upgradeToRevocableSession","linkWith"],e),n.UserController=e},getUserController:function(){return n.UserController},setLiveQueryController:function(e){r("LiveQueryController",["subscribe","unsubscribe","open","close"],e),n.LiveQueryController=e},getLiveQueryController:function(){return n.LiveQueryController},setHooksController:function(e){r("HooksController",["create","get","update","remove"],e),n.HooksController=e},getHooksController:function(){return n.HooksController}}}).call(this,e("_process"))},{_process:58}],4:[function(e,t,r){"use strict";t.exports=e("events").EventEmitter},{events:129}],5:[function(e,t,r){"use strict";var n=e("babel-runtime/helpers/interop-require-default")["default"];Object.defineProperty(r,"__esModule",{value:!0});var a,i,s=e("./parseDate"),o=n(s),u=e("./ParseUser"),l=n(u),c=!1;r["default"]={init:function(e){if("undefined"==typeof FB)throw new Error("The Facebook JavaScript SDK must be loaded before calling init.");if(i={},e)for(var t in e)i[t]=e[t];if(i.status&&"undefined"!=typeof console){var r=console.warn||console.log||function(){};r.call(console,'The "status" flag passed into FB.init, when set to true, can interfere with Parse Facebook integration, so it has been suppressed. Please call FB.getLoginStatus() explicitly if you require this behavior.')}i.status=!1,FB.init(i),l["default"]._registerAuthenticationProvider({authenticate:function(e){var t=this;"undefined"==typeof FB&&e.error(this,"Facebook SDK not found."),FB.login(function(r){r.authResponse?e.success&&e.success(t,{id:r.authResponse.userID,access_token:r.authResponse.accessToken,expiration_date:new Date(1e3*r.authResponse.expiresIn+(new Date).getTime()).toJSON()}):e.error&&e.error(t,r)},{scope:a})},restoreAuthentication:function(e){if(e){var t=(0,o["default"])(e.expiration_date),r=t?(t.getTime()-(new Date).getTime())/1e3:0,n={userID:e.id,accessToken:e.access_token,expiresIn:r},a={};if(i)for(var s in i)a[s]=i[s];a.authResponse=n,a.status=!1;var u=FB.getAuthResponse();u&&u.userID!==n.userID&&FB.logout(),FB.init(a)}return!0},getAuthType:function(){return"facebook"},deauthenticate:function(){this.restoreAuthentication(null)}}),c=!0},isLinked:function(e){return e._isLinked("facebook")},logIn:function(e,t){if(e&&"string"!=typeof e){var r={};if(t)for(var n in t)r[n]=t[n];return r.authData=e,l["default"]._logInWith("facebook",r)}if(!c)throw new Error("You must initialize FacebookUtils before calling logIn.");return a=e,l["default"]._logInWith("facebook",t)},link:function(e,t,r){if(t&&"string"!=typeof t){var n={};if(r)for(var i in r)n[i]=r[i];return n.authData=t,e._linkWith("facebook",n)}if(!c)throw new Error("You must initialize FacebookUtils before calling link.");return a=t,e._linkWith("facebook",r)},unlink:function(e,t){if(!c)throw new Error("You must initialize FacebookUtils before calling unlink.");return e._unlinkFrom("facebook",t)}},t.exports=r["default"]},{"./ParseUser":25,"./parseDate":40,"babel-runtime/helpers/interop-require-default":56}],6:[function(e,t,r){"use strict";function n(){return Math.floor(65536*(1+Math.random())).toString(16).substring(1)}function a(){return n()+n()+"-"+n()+"-"+n()+"-"+n()+"-"+n()+n()+n()}var i=e("babel-runtime/helpers/interop-require-default")["default"],s=e("./CoreManager"),o=(i(s),e("./ParsePromise")),u=i(o),l=e("./Storage"),c=i(l),f=null;t.exports={currentInstallationId:function(){if("string"==typeof f)return u["default"].as(f);var e=c["default"].generatePath("installationId");return c["default"].getItemAsync(e).then(function(t){return t?(f=t,t):(t=a(),c["default"].setItemAsync(e,t).then(function(){return f=t,t}))})},_clearCache:function(){f=null},_setInstallationIdCache:function(e){f=e}}},{"./CoreManager":3,"./ParsePromise":20,"./Storage":29,"babel-runtime/helpers/interop-require-default":56}],7:[function(e,t,r){"use strict";var n=e("babel-runtime/helpers/get")["default"],a=e("babel-runtime/helpers/inherits")["default"],i=e("babel-runtime/helpers/create-class")["default"],s=e("babel-runtime/helpers/class-call-check")["default"],o=e("babel-runtime/core-js/map")["default"],u=e("babel-runtime/core-js/get-iterator")["default"],l=e("babel-runtime/helpers/interop-require-default")["default"];Object.defineProperty(r,"__esModule",{value:!0});var c=e("./EventEmitter"),f=l(c),d=e("./ParsePromise"),h=l(d),p=e("./ParseObject"),v=l(p),y=e("./LiveQuerySubscription"),b=l(y),g={INITIALIZED:"initialized",CONNECTING:"connecting",CONNECTED:"connected",CLOSED:"closed",RECONNECTING:"reconnecting",DISCONNECTED:"disconnected"},_={CONNECT:"connect",SUBSCRIBE:"subscribe",UNSUBSCRIBE:"unsubscribe",ERROR:"error"},m={CONNECTED:"connected",SUBSCRIBED:"subscribed",UNSUBSCRIBED:"unsubscribed",ERROR:"error",CREATE:"create",UPDATE:"update",ENTER:"enter",LEAVE:"leave",DELETE:"delete"},O={CLOSE:"close",ERROR:"error",OPEN:"open"},C={OPEN:"open",CLOSE:"close",ERROR:"error",CREATE:"create",UPDATE:"update",ENTER:"enter",LEAVE:"leave",DELETE:"delete"},k=function(e){return Math.random()*Math.min(30,Math.pow(2,e)-1)*1e3},w=function(e){function t(e){var r=e.applicationId,a=e.serverURL,i=e.javascriptKey,u=e.masterKey,l=e.sessionToken;if(s(this,t),n(Object.getPrototypeOf(t.prototype),"constructor",this).call(this),!a||0!==a.indexOf("ws"))throw new Error("You need to set a proper Parse LiveQuery server url before using LiveQueryClient");this.reconnectHandle=null,this.attempts=1,this.id=0,this.requestId=1,this.serverURL=a,this.applicationId=r,this.javascriptKey=i,this.masterKey=u,this.sessionToken=l,this.connectPromise=new h["default"],this.subscriptions=new o,this.state=g.INITIALIZED}return a(t,e),i(t,[{key:"shouldOpen",value:function(){return this.state===g.INITIALIZED||this.state===g.DISCONNECTED}},{key:"subscribe",value:function(e,t){var r=this;if(e){var n=e.toJSON().where,a=e.className,i={op:_.SUBSCRIBE,requestId:this.requestId,query:{className:a,where:n}};t&&(i.sessionToken=t);var s=new b["default"](this.requestId,e,t);return this.subscriptions.set(this.requestId,s),this.requestId+=1,this.connectPromise.then(function(){r.socket.send(JSON.stringify(i))}),s.on("error",function(){}),s}}},{key:"unsubscribe",value:function(e){var t=this;if(e){this.subscriptions["delete"](e.id);var r={op:_.UNSUBSCRIBE,requestId:e.id};this.connectPromise.then(function(){t.socket.send(JSON.stringify(r))})}}},{key:"open",value:function(){var e=this,t=this._getWebSocketImplementation();return t?(this.state!==g.RECONNECTING&&(this.state=g.CONNECTING),this.socket=new t(this.serverURL),this.socket.onopen=function(){e._handleWebSocketOpen()},this.socket.onmessage=function(t){e._handleWebSocketMessage(t)},this.socket.onclose=function(){e._handleWebSocketClose()},void(this.socket.onerror=function(t){console.log("error on socket"),e._handleWebSocketError(t)})):void this.emit(O.ERROR,"Can not find WebSocket implementation")}},{key:"resubscribe",value:function(){var e=this;this.subscriptions.forEach(function(t,r){var n=t.query,a=n.toJSON().where,i=n.className,s=t.sessionToken,o={op:_.SUBSCRIBE,requestId:r,query:{className:i,where:a}};s&&(o.sessionToken=s),e.connectPromise.then(function(){e.socket.send(JSON.stringify(o))})})}},{key:"close",value:function(){if(this.state!==g.INITIALIZED&&this.state!==g.DISCONNECTED){this.state=g.DISCONNECTED,this.socket.close();var e=!0,t=!1,r=void 0;try{for(var n,a=u(this.subscriptions.values());!(e=(n=a.next()).done);e=!0){var i=n.value;i.emit(C.CLOSE)}}catch(s){t=!0,r=s}finally{try{!e&&a["return"]&&a["return"]()}finally{if(t)throw r}}this._handleReset(),this.emit(O.CLOSE)}}},{key:"_getWebSocketImplementation",value:function(){return"function"==typeof WebSocket||"object"==typeof WebSocket?WebSocket:null}},{key:"_handleReset",value:function(){this.attempts=1,this.id=0,this.requestId=1,this.connectPromise=new h["default"],this.subscriptions=new o}},{key:"_handleWebSocketOpen",value:function(){this.attempts=1;var e={op:_.CONNECT,applicationId:this.applicationId,javascriptKey:this.javascriptKey,masterKey:this.masterKey,sessionToken:this.sessionToken};this.socket.send(JSON.stringify(e))}},{key:"_handleWebSocketMessage",value:function(e){var t=e.data;"string"==typeof t&&(t=JSON.parse(t));var r=null;switch(t.requestId&&(r=this.subscriptions.get(t.requestId)),t.op){case m.CONNECTED:this.state===g.RECONNECTING&&this.resubscribe(),this.emit(O.OPEN),this.id=t.clientId,this.connectPromise.resolve(),this.state=g.CONNECTED;break;case m.SUBSCRIBED:r&&r.emit(C.OPEN);break;case m.ERROR:t.requestId?r&&r.emit(C.ERROR,t.error):this.emit(O.ERROR,t.error);break;case m.UNSUBSCRIBED:break;default:var n=t.object.className;delete t.object.__type,delete t.object.className;var a=new v["default"](n);if(a._finishFetch(t.object),!r)break;r.emit(t.op,a)}}},{key:"_handleWebSocketClose",value:function(){if(this.state!==g.DISCONNECTED){this.state=g.CLOSED,this.emit(O.CLOSE);var e=!0,t=!1,r=void 0;try{for(var n,a=u(this.subscriptions.values());!(e=(n=a.next()).done);e=!0){var i=n.value;i.emit(C.CLOSE)}}catch(s){t=!0,r=s}finally{try{!e&&a["return"]&&a["return"]()}finally{if(t)throw r}}this._handleReconnect()}}},{key:"_handleWebSocketError",value:function(e){this.emit(O.ERROR,e);var t=!0,r=!1,n=void 0;try{for(var a,i=u(this.subscriptions.values());!(t=(a=i.next()).done);t=!0){var s=a.value;s.emit(C.ERROR)}}catch(o){r=!0,n=o}finally{try{!t&&i["return"]&&i["return"]()}finally{if(r)throw n}}this._handleReconnect()}},{key:"_handleReconnect",value:function(){var e=this;if(this.state!==g.DISCONNECTED){this.state=g.RECONNECTING;var t=k(this.attempts);this.reconnectHandle?clearTimeout(this.reconnectHandle):console.info("attempting to reconnect"),this.reconnectHandle=setTimeout(function(){e.attempts++,e.connectPromise=new h["default"],e.open()}.bind(this),t)}}}]),t}(f["default"]);r["default"]=w,t.exports=r["default"]},{"./EventEmitter":4,"./LiveQuerySubscription":8,"./ParseObject":18,"./ParsePromise":20,"babel-runtime/core-js/get-iterator":43,"babel-runtime/core-js/map":44,"babel-runtime/helpers/class-call-check":52,"babel-runtime/helpers/create-class":53,"babel-runtime/helpers/get":54,"babel-runtime/helpers/inherits":55,"babel-runtime/helpers/interop-require-default":56}],8:[function(e,t,r){"use strict";var n=e("babel-runtime/helpers/get")["default"],a=e("babel-runtime/helpers/inherits")["default"],i=e("babel-runtime/helpers/create-class")["default"],s=e("babel-runtime/helpers/class-call-check")["default"],o=e("babel-runtime/helpers/interop-require-default")["default"];Object.defineProperty(r,"__esModule",{value:!0});var u=e("./EventEmitter"),l=o(u),c=e("./CoreManager"),f=o(c),d=function(e){function t(e,r,a){s(this,t),n(Object.getPrototypeOf(t.prototype),"constructor",this).call(this),this.id=e,this.query=r,this.sessionToken=a}return a(t,e),i(t,[{key:"unsubscribe",value:function(){var e=this,t=this;f["default"].getLiveQueryController().getDefaultLiveQueryClient().then(function(r){r.unsubscribe(t),t.emit("close"),e.resolve()})}}]),t}(l["default"]);r["default"]=d,t.exports=r["default"]},{"./CoreManager":3,"./EventEmitter":4,"babel-runtime/helpers/class-call-check":52,"babel-runtime/helpers/create-class":53,"babel-runtime/helpers/get":54,"babel-runtime/helpers/inherits":55,"babel-runtime/helpers/interop-require-default":56}],9:[function(e,t,r){"use strict";function n(){return{serverData:{},pendingOps:[{}],objectCache:{},tasks:new k["default"],existed:!1}}function a(e,t){for(var r in t)"undefined"!=typeof t[r]?e[r]=t[r]:delete e[r]}function i(e,t,r){var n=e.length-1;r?e[n][t]=r:delete e[n][t]}function s(e){e.push({})}function o(e){var t=e.shift();return e.length||(e[0]={}),t}function u(e){var t=o(e),r=e[0];for(var n in t)if(r[n]&&t[n]){var a=r[n].mergeWith(t[n]);a&&(r[n]=a)}else r[n]=t[n]}function l(e,t,r,n,a){for(var i=e[a],s=0;s<t.length;s++)t[s][a]&&(t[s][a]instanceof w.RelationOp?n&&(i=t[s][a].applyTo(i,{className:r,id:n},a)):i=t[s][a].applyTo(i));return i}function c(e,t,r,n){var a={},i=void 0;for(i in e)a[i]=e[i];for(var s=0;s<t.length;s++)for(i in t[s])t[s][i]instanceof w.RelationOp?n&&(a[i]=t[s][i].applyTo(a[i],{className:r,id:n},i)):a[i]=t[s][i].applyTo(a[i]);return a}function f(e,t,r){for(var n in r){var a=r[n];if(e[n]=a,a&&"object"==typeof a&&!(a instanceof g["default"])&&!(a instanceof y["default"])&&!(a instanceof O["default"])){var i=(0,p["default"])(a,!1,!0);t[n]=JSON.stringify(i)}}}var d=e("babel-runtime/helpers/interop-require-default")["default"];Object.defineProperty(r,"__esModule",{value:!0}),r.defaultState=n,r.setServerData=a,r.setPendingOp=i,r.pushPendingState=s,r.popPendingState=o,r.mergeFirstPendingState=u,r.estimateAttribute=l,r.estimateAttributes=c,r.commitServerChanges=f;var h=e("./encode"),p=d(h),v=e("./ParseFile"),y=d(v),b=e("./ParseObject"),g=d(b),_=e("./ParsePromise"),m=(d(_),e("./ParseRelation")),O=d(m),C=e("./TaskQueue"),k=d(C),w=e("./ParseOp")},{"./ParseFile":14,"./ParseObject":18,"./ParseOp":19,"./ParsePromise":20,"./ParseRelation":22,"./TaskQueue":31,"./encode":36,"babel-runtime/helpers/interop-require-default":56}],10:[function(e,t,r){"use strict";var n=e("babel-runtime/helpers/interop-require-default")["default"],a=e("babel-runtime/helpers/interop-require-wildcard")["default"],i=e("./decode"),s=n(i),o=e("./encode"),u=n(o),l=e("./CoreManager"),c=n(l),f=e("./InstallationController"),d=n(f),h=e("./ParseOp"),p=a(h),v=e("./RESTController"),y=n(v),b={initialize:function(e,t){c["default"].get("IS_NODE")&&console.log("It looks like you're using the browser version of the SDK in a node.js environment. You should require('parse/node') instead."),b._initialize(e,t)},_initialize:function(e,t,r){c["default"].set("APPLICATION_ID",e),c["default"].set("JAVASCRIPT_KEY",t),c["default"].set("MASTER_KEY",r),c["default"].set("USE_MASTER_KEY",!1)}};Object.defineProperty(b,"applicationId",{get:function(){return c["default"].get("APPLICATION_ID")},set:function(e){c["default"].set("APPLICATION_ID",e)}}),Object.defineProperty(b,"javaScriptKey",{get:function(){return c["default"].get("JAVASCRIPT_KEY")},set:function(e){c["default"].set("JAVASCRIPT_KEY",e)}}),Object.defineProperty(b,"masterKey",{get:function(){return c["default"].get("MASTER_KEY")},set:function(e){c["default"].set("MASTER_KEY",e)}}),Object.defineProperty(b,"serverURL",{get:function(){return c["default"].get("SERVER_URL")},set:function(e){c["default"].set("SERVER_URL",e)}}),Object.defineProperty(b,"liveQueryServerURL",{get:function(){return c["default"].get("LIVEQUERY_SERVER_URL")},set:function(e){c["default"].set("LIVEQUERY_SERVER_URL",e)}}),b.ACL=e("./ParseACL"),b.Analytics=e("./Analytics"),b.Cloud=e("./Cloud"),b.CoreManager=e("./CoreManager"),b.Config=e("./ParseConfig"),b.Error=e("./ParseError"),b.FacebookUtils=e("./FacebookUtils"),b.File=e("./ParseFile"),b.GeoPoint=e("./ParseGeoPoint"),b.Installation=e("./ParseInstallation"),b.Object=e("./ParseObject"),b.Op={Set:p.SetOp,Unset:p.UnsetOp,Increment:p.IncrementOp,Add:p.AddOp,Remove:p.RemoveOp,AddUnique:p.AddUniqueOp,Relation:p.RelationOp},b.Promise=e("./ParsePromise"),b.Push=e("./Push"),b.Query=e("./ParseQuery"),b.Relation=e("./ParseRelation"),b.Role=e("./ParseRole"),b.Session=e("./ParseSession"),b.Storage=e("./Storage"),b.User=e("./ParseUser"),b.LiveQuery=e("./ParseLiveQuery"),b.LiveQueryClient=e("./LiveQueryClient"),b._request=function(){for(var e=arguments.length,t=Array(e),r=0;r<e;r++)t[r]=arguments[r];return c["default"].getRESTController().request.apply(null,t)},b._ajax=function(){for(var e=arguments.length,t=Array(e),r=0;r<e;r++)t[r]=arguments[r];return c["default"].getRESTController().ajax.apply(null,t)},b._decode=function(e,t){return(0,s["default"])(t)},b._encode=function(e,t,r){return(0,u["default"])(e,r)},b._getInstallationId=function(){return c["default"].getInstallationController().currentInstallationId()},c["default"].setInstallationController(d["default"]),c["default"].setRESTController(y["default"]),b.Parse=b,t.exports=b},{"./Analytics":1,"./Cloud":2,"./CoreManager":3,"./FacebookUtils":5,"./InstallationController":6,"./LiveQueryClient":7,"./ParseACL":11,"./ParseConfig":12,"./ParseError":13,"./ParseFile":14,"./ParseGeoPoint":15,"./ParseInstallation":16,"./ParseLiveQuery":17,"./ParseObject":18,"./ParseOp":19,"./ParsePromise":20,"./ParseQuery":21,"./ParseRelation":22,"./ParseRole":23,"./ParseSession":24,"./ParseUser":25,"./Push":26,"./RESTController":27,"./Storage":29,"./decode":35,"./encode":36,"babel-runtime/helpers/interop-require-default":56,"babel-runtime/helpers/interop-require-wildcard":57}],11:[function(e,t,r){"use strict";var n=e("babel-runtime/helpers/create-class")["default"],a=e("babel-runtime/helpers/class-call-check")["default"],i=e("babel-runtime/core-js/object/keys")["default"],s=e("babel-runtime/helpers/interop-require-default")["default"];Object.defineProperty(r,"__esModule",{value:!0});var o=e("./ParseRole"),u=s(o),l=e("./ParseUser"),c=s(l),f="*",d=function(){function e(t){if(a(this,e),this.permissionsById={},t&&"object"==typeof t)if(t instanceof c["default"])this.setReadAccess(t,!0),this.setWriteAccess(t,!0);else for(var r in t){var n=t[r];if("string"!=typeof r)throw new TypeError("Tried to create an ACL with an invalid user id.");this.permissionsById[r]={};for(var i in n){var s=n[i];if("read"!==i&&"write"!==i)throw new TypeError("Tried to create an ACL with an invalid permission type.");if("boolean"!=typeof s)throw new TypeError("Tried to create an ACL with an invalid permission value.");this.permissionsById[r][i]=s}}else if("function"==typeof t)throw new TypeError("ParseACL constructed with a function. Did you forget ()?")}return n(e,[{key:"toJSON",value:function(){var e={};for(var t in this.permissionsById)e[t]=this.permissionsById[t];return e}},{key:"equals",value:function(t){if(!(t instanceof e))return!1;var r=i(this.permissionsById),n=i(t.permissionsById);if(r.length!==n.length)return!1;for(var a in this.permissionsById){if(!t.permissionsById[a])return!1;if(this.permissionsById[a].read!==t.permissionsById[a].read)return!1;if(this.permissionsById[a].write!==t.permissionsById[a].write)return!1}return!0}},{key:"_setAccess",value:function(e,t,r){if(t instanceof c["default"])t=t.id;else if(t instanceof u["default"]){var n=t.getName();if(!n)throw new TypeError("Role must have a name");t="role:"+n}if("string"!=typeof t)throw new TypeError("userId must be a string.");if("boolean"!=typeof r)throw new TypeError("allowed must be either true or false.");var a=this.permissionsById[t];if(!a){if(!r)return;a={},this.permissionsById[t]=a}r?this.permissionsById[t][e]=!0:(delete a[e],0===i(a).length&&delete this.permissionsById[t])}},{key:"_getAccess",value:function(e,t){if(t instanceof c["default"]){if(t=t.id,!t)throw new Error("Cannot get access for a ParseUser without an ID")}else if(t instanceof u["default"]){var r=t.getName();if(!r)throw new TypeError("Role must have a name");t="role:"+r}var n=this.permissionsById[t];return!!n&&!!n[e]}},{key:"setReadAccess",value:function(e,t){this._setAccess("read",e,t)}},{key:"getReadAccess",value:function(e){return this._getAccess("read",e)}},{key:"setWriteAccess",value:function(e,t){this._setAccess("write",e,t)}},{key:"getWriteAccess",value:function(e){return this._getAccess("write",e)}},{key:"setPublicReadAccess",value:function(e){this.setReadAccess(f,e)}},{key:"getPublicReadAccess",value:function(){return this.getReadAccess(f)}},{key:"setPublicWriteAccess",value:function(e){this.setWriteAccess(f,e)}},{key:"getPublicWriteAccess",value:function(){return this.getWriteAccess(f)}},{key:"getRoleReadAccess",value:function(e){if(e instanceof u["default"]&&(e=e.getName()),"string"!=typeof e)throw new TypeError("role must be a ParseRole or a String");return this.getReadAccess("role:"+e)}},{key:"getRoleWriteAccess",value:function(e){if(e instanceof u["default"]&&(e=e.getName()),"string"!=typeof e)throw new TypeError("role must be a ParseRole or a String");return this.getWriteAccess("role:"+e)}},{key:"setRoleReadAccess",value:function(e,t){if(e instanceof u["default"]&&(e=e.getName()),"string"!=typeof e)throw new TypeError("role must be a ParseRole or a String");this.setReadAccess("role:"+e,t)}},{key:"setRoleWriteAccess",value:function(e,t){if(e instanceof u["default"]&&(e=e.getName()),"string"!=typeof e)throw new TypeError("role must be a ParseRole or a String");this.setWriteAccess("role:"+e,t)}}]),e}();r["default"]=d,t.exports=r["default"]},{"./ParseRole":23,"./ParseUser":25,"babel-runtime/core-js/object/keys":49,"babel-runtime/helpers/class-call-check":52,"babel-runtime/helpers/create-class":53,"babel-runtime/helpers/interop-require-default":56}],12:[function(e,t,r){"use strict";function n(e){try{var t=JSON.parse(e);if(t&&"object"==typeof t)return(0,c["default"])(t)}catch(r){return null}}var a=e("babel-runtime/helpers/create-class")["default"],i=e("babel-runtime/helpers/class-call-check")["default"],s=e("babel-runtime/helpers/interop-require-default")["default"];Object.defineProperty(r,"__esModule",{value:!0});var o=e("./CoreManager"),u=s(o),l=e("./decode"),c=s(l),f=e("./encode"),d=(s(f),e("./escape")),h=s(d),p=e("./ParseError"),v=s(p),y=e("./ParsePromise"),b=s(y),g=e("./Storage"),_=s(g),m=function(){function e(){i(this,e),this.attributes={},this._escapedAttributes={}}return a(e,[{key:"get",value:function(e){return this.attributes[e]}},{key:"escape",value:function(e){var t=this._escapedAttributes[e];if(t)return t;var r=this.attributes[e],n="";return null!=r&&(n=(0,h["default"])(r.toString())),this._escapedAttributes[e]=n,n}}],[{key:"current",value:function(){var e=u["default"].getConfigController();return e.current()}},{key:"get",value:function(e){e=e||{};var t=u["default"].getConfigController();return t.get()._thenRunCallbacks(e)}}]),e}();r["default"]=m;var O=null,C="currentConfig";u["default"].setConfigController({current:function(){if(O)return O;var e,t=new m,r=_["default"].generatePath(C);if(!_["default"].async()){if(e=_["default"].getItem(r)){var a=n(e);a&&(t.attributes=a,O=t)}return t}return _["default"].getItemAsync(r).then(function(e){if(e){var r=n(e);r&&(t.attributes=r,O=t)}return t})},get:function(){var e=u["default"].getRESTController();return e.request("GET","config",{},{}).then(function(e){if(!e||!e.params){var t=new v["default"](v["default"].INVALID_JSON,"Config JSON response invalid.");return b["default"].error(t)}var r=new m;r.attributes={};for(var n in e.params)r.attributes[n]=(0,c["default"])(e.params[n]);return O=r,_["default"].setItemAsync(_["default"].generatePath(C),JSON.stringify(e.params)).then(function(){return r})})}}),t.exports=r["default"]},{"./CoreManager":3,"./ParseError":13,"./ParsePromise":20,"./Storage":29,"./decode":35,"./encode":36,"./escape":38,"babel-runtime/helpers/class-call-check":52,"babel-runtime/helpers/create-class":53,"babel-runtime/helpers/interop-require-default":56}],13:[function(e,t,r){"use strict";var n=e("babel-runtime/helpers/class-call-check")["default"];Object.defineProperty(r,"__esModule",{value:!0});var a=function i(e,t){n(this,i),this.code=e,this.message=t};r["default"]=a,a.OTHER_CAUSE=-1,a.INTERNAL_SERVER_ERROR=1,a.CONNECTION_FAILED=100,a.OBJECT_NOT_FOUND=101,a.INVALID_QUERY=102,a.INVALID_CLASS_NAME=103,a.MISSING_OBJECT_ID=104,a.INVALID_KEY_NAME=105,a.INVALID_POINTER=106,a.INVALID_JSON=107,a.COMMAND_UNAVAILABLE=108,a.NOT_INITIALIZED=109,a.INCORRECT_TYPE=111,a.INVALID_CHANNEL_NAME=112,a.PUSH_MISCONFIGURED=115,a.OBJECT_TOO_LARGE=116,a.OPERATION_FORBIDDEN=119,a.CACHE_MISS=120,a.INVALID_NESTED_KEY=121,a.INVALID_FILE_NAME=122,a.INVALID_ACL=123,a.TIMEOUT=124,a.INVALID_EMAIL_ADDRESS=125,a.MISSING_CONTENT_TYPE=126,a.MISSING_CONTENT_LENGTH=127,a.INVALID_CONTENT_LENGTH=128,a.FILE_TOO_LARGE=129,a.FILE_SAVE_ERROR=130,a.DUPLICATE_VALUE=137,a.INVALID_ROLE_NAME=139,a.EXCEEDED_QUOTA=140,a.SCRIPT_FAILED=141,a.VALIDATION_ERROR=142,a.INVALID_IMAGE_DATA=143,a.UNSAVED_FILE_ERROR=151,a.INVALID_PUSH_TIME_ERROR=152,a.FILE_DELETE_ERROR=153,a.REQUEST_LIMIT_EXCEEDED=155,a.INVALID_EVENT_NAME=160,a.USERNAME_MISSING=200,a.PASSWORD_MISSING=201,a.USERNAME_TAKEN=202,a.EMAIL_TAKEN=203,a.EMAIL_MISSING=204,a.EMAIL_NOT_FOUND=205,a.SESSION_MISSING=206,a.MUST_CREATE_USER_THROUGH_SIGNUP=207,a.ACCOUNT_ALREADY_LINKED=208,a.INVALID_SESSION_TOKEN=209,a.LINKED_ID_MISSING=250,a.INVALID_LINKED_SESSION=251,a.UNSUPPORTED_SERVICE=252,a.AGGREGATE_ERROR=600,a.FILE_READ_ERROR=601,a.X_DOMAIN_REQUEST=602,t.exports=r["default"]},{"babel-runtime/helpers/class-call-check":52}],14:[function(e,t,r){"use strict";function n(e){if(e<26)return String.fromCharCode(65+e);if(e<52)return String.fromCharCode(97+(e-26));if(e<62)return String.fromCharCode(48+(e-52));if(62===e)return"+";if(63===e)return"/";throw new TypeError("Tried to encode large digit "+e+" in base64.")}var a=e("babel-runtime/helpers/create-class")["default"],i=e("babel-runtime/helpers/class-call-check")["default"],s=e("babel-runtime/helpers/interop-require-default")["default"];Object.defineProperty(r,"__esModule",{value:!0});var o=e("./CoreManager"),u=s(o),l=e("./ParsePromise"),c=(s(l),function(){function e(t,r,n){i(this,e);var a=n||"";if(this._name=t,void 0!==r)if(Array.isArray(r))this._source={format:"base64",base64:e.encodeBase64(r),type:a};else if("undefined"!=typeof File&&r instanceof File)this._source={format:"file",file:r,type:a};else{if(!r||"undefined"==typeof r.base64)throw new TypeError("Cannot create a Parse.File with that data.");var s=r.base64,o=s.indexOf(",");if(o!==-1){var u=/^data:([a-zA-Z]*\/[a-zA-Z+.-]*);(charset=[a-zA-Z0-9\-\/\s]*,)?base64,/.exec(s.slice(0,o+1));this._source={format:"base64",base64:s.slice(o+1),type:u[1]}}else this._source={format:"base64",base64:s,type:a}}}return a(e,[{key:"name",value:function(){return this._name}},{key:"url",value:function(e){if(e=e||{},this._url)return e.forceSecure?this._url.replace(/^http:\/\//i,"https://"):this._url}},{key:"save",value:function(e){var t=this;e=e||{};var r=u["default"].getFileController();if(this._previousSave||("file"===this._source.format?this._previousSave=r.saveFile(this._name,this._source).then(function(e){return t._name=e.name,t._url=e.url,t}):this._previousSave=r.saveBase64(this._name,this._source).then(function(e){return t._name=e.name,t._url=e.url,t})),this._previousSave)return this._previousSave._thenRunCallbacks(e)}},{key:"toJSON",value:function(){return{__type:"File",name:this._name,url:this._url
}}},{key:"equals",value:function(t){return this===t||t instanceof e&&this.name()===t.name()&&this.url()===t.url()&&"undefined"!=typeof this.url()}}],[{key:"fromJSON",value:function(t){if("File"!==t.__type)throw new TypeError("JSON object does not represent a ParseFile");var r=new e(t.name);return r._url=t.url,r}},{key:"encodeBase64",value:function(e){var t=[];t.length=Math.ceil(e.length/3);for(var r=0;r<t.length;r++){var a=e[3*r],i=e[3*r+1]||0,s=e[3*r+2]||0,o=3*r+1<e.length,u=3*r+2<e.length;t[r]=[n(a>>2&63),n(a<<4&48|i>>4&15),o?n(i<<2&60|s>>6&3):"=",u?n(63&s):"="].join("")}return t.join("")}}]),e}());r["default"]=c,u["default"].setFileController({saveFile:function(e,t){if("file"!==t.format)throw new Error("saveFile can only be used with File-type sources.");var r={"X-Parse-Application-ID":u["default"].get("APPLICATION_ID"),"X-Parse-JavaScript-Key":u["default"].get("JAVASCRIPT_KEY"),"Content-Type":t.type||(t.file?t.file.type:null)},n=u["default"].get("SERVER_URL");return"/"!==n[n.length-1]&&(n+="/"),n+="files/"+e,u["default"].getRESTController().ajax("POST",n,t.file,r)},saveBase64:function(e,t){if("base64"!==t.format)throw new Error("saveBase64 can only be used with Base64-type sources.");var r={base64:t.base64};return t.type&&(r._ContentType=t.type),u["default"].getRESTController().request("POST","files/"+e,r)}}),t.exports=r["default"]},{"./CoreManager":3,"./ParsePromise":20,"babel-runtime/helpers/class-call-check":52,"babel-runtime/helpers/create-class":53,"babel-runtime/helpers/interop-require-default":56}],15:[function(e,t,r){"use strict";var n=e("babel-runtime/helpers/create-class")["default"],a=e("babel-runtime/helpers/class-call-check")["default"],i=e("babel-runtime/helpers/interop-require-default")["default"];Object.defineProperty(r,"__esModule",{value:!0});var s=e("./ParsePromise"),o=i(s),u=function(){function e(t,r){a(this,e),Array.isArray(t)?(e._validate(t[0],t[1]),this._latitude=t[0],this._longitude=t[1]):"object"==typeof t?(e._validate(t.latitude,t.longitude),this._latitude=t.latitude,this._longitude=t.longitude):"number"==typeof t&&"number"==typeof r?(e._validate(t,r),this._latitude=t,this._longitude=r):(this._latitude=0,this._longitude=0)}return n(e,[{key:"toJSON",value:function(){return e._validate(this._latitude,this._longitude),{__type:"GeoPoint",latitude:this._latitude,longitude:this._longitude}}},{key:"equals",value:function(t){return t instanceof e&&this.latitude===t.latitude&&this.longitude===t.longitude}},{key:"radiansTo",value:function(e){var t=Math.PI/180,r=this.latitude*t,n=this.longitude*t,a=e.latitude*t,i=e.longitude*t,s=Math.sin((r-a)/2),o=Math.sin((n-i)/2),u=s*s+Math.cos(r)*Math.cos(a)*o*o;return u=Math.min(1,u),2*Math.asin(Math.sqrt(u))}},{key:"kilometersTo",value:function(e){return 6371*this.radiansTo(e)}},{key:"milesTo",value:function(e){return 3958.8*this.radiansTo(e)}},{key:"latitude",get:function(){return this._latitude},set:function(t){e._validate(t,this.longitude),this._latitude=t}},{key:"longitude",get:function(){return this._longitude},set:function(t){e._validate(this.latitude,t),this._longitude=t}}],[{key:"_validate",value:function(e,t){if(e!==e||t!==t)throw new TypeError("GeoPoint latitude and longitude must be valid numbers");if(e<-90)throw new TypeError("GeoPoint latitude out of bounds: "+e+" < -90.0.");if(e>90)throw new TypeError("GeoPoint latitude out of bounds: "+e+" > 90.0.");if(t<-180)throw new TypeError("GeoPoint longitude out of bounds: "+t+" < -180.0.");if(t>180)throw new TypeError("GeoPoint longitude out of bounds: "+t+" > 180.0.")}},{key:"current",value:function(t){var r=new o["default"];return navigator.geolocation.getCurrentPosition(function(t){r.resolve(new e(t.coords.latitude,t.coords.longitude))},function(e){r.reject(e)}),r._thenRunCallbacks(t)}}]),e}();r["default"]=u,t.exports=r["default"]},{"./ParsePromise":20,"babel-runtime/helpers/class-call-check":52,"babel-runtime/helpers/create-class":53,"babel-runtime/helpers/interop-require-default":56}],16:[function(e,t,r){"use strict";var n=e("babel-runtime/helpers/get")["default"],a=e("babel-runtime/helpers/inherits")["default"],i=e("babel-runtime/helpers/class-call-check")["default"],s=e("babel-runtime/helpers/interop-require-default")["default"];Object.defineProperty(r,"__esModule",{value:!0});var o=e("./ParseObject"),u=s(o),l=function(e){function t(e){if(i(this,t),n(Object.getPrototypeOf(t.prototype),"constructor",this).call(this,"_Installation"),e&&"object"==typeof e&&!this.set(e||{}))throw new Error("Can't create an invalid Session")}return a(t,e),t}(u["default"]);r["default"]=l,u["default"].registerSubclass("_Installation",l),t.exports=r["default"]},{"./ParseObject":18,"babel-runtime/helpers/class-call-check":52,"babel-runtime/helpers/get":54,"babel-runtime/helpers/inherits":55,"babel-runtime/helpers/interop-require-default":56}],17:[function(e,t,r){"use strict";function n(){var e=f["default"].getUserController();return e.currentUserAsync().then(function(e){return e?e.getSessionToken():void 0})}function a(){return f["default"].getLiveQueryController().getDefaultLiveQueryClient()}var i=e("babel-runtime/helpers/interop-require-default")["default"];Object.defineProperty(r,"__esModule",{value:!0});var s=e("./EventEmitter"),o=i(s),u=e("./LiveQueryClient"),l=i(u),c=e("./CoreManager"),f=i(c),d=e("./ParsePromise"),h=i(d),p=new o["default"];p.open=function(){var e=f["default"].getLiveQueryController();e.open()},p.close=function(){var e=f["default"].getLiveQueryController();e.close()},p.on("error",function(){}),r["default"]=p;var v=void 0;f["default"].setLiveQueryController({setDefaultLiveQueryClient:function(e){v=e},getDefaultLiveQueryClient:function(){return v?h["default"].as(v):n().then(function(e){var t=f["default"].get("LIVEQUERY_SERVER_URL");if(t&&0!==t.indexOf("ws"))throw new Error("You need to set a proper Parse LiveQuery server url before using LiveQueryClient");if(!t){var r=f["default"].get("SERVER_URL"),n="ws://";0===r.indexOf("https")&&(n="wss://");var a=r.replace(/^https?:\/\//,"");t=n+a,f["default"].set("LIVEQUERY_SERVER_URL",t)}var i=f["default"].get("APPLICATION_ID"),s=f["default"].get("JAVASCRIPT_KEY"),o=f["default"].get("MASTER_KEY");return v=new l["default"]({applicationId:i,serverURL:t,javascriptKey:s,masterKey:o,sessionToken:e}),v.on("error",function(e){p.emit("error",e)}),v.on("open",function(){p.emit("open")}),v.on("close",function(){p.emit("close")}),v})},open:function(){var e=this;a().then(function(t){e.resolve(t.open())})},close:function(){var e=this;a().then(function(t){e.resolve(t.close())})},subscribe:function(e){var t=this,r=new o["default"];return a().then(function(a){a.shouldOpen()&&a.open();var i=n();return i.then(function(n){var i=a.subscribe(e,n);r.id=i.id,r.query=i.query,r.sessionToken=i.sessionToken,r.unsubscribe=i.unsubscribe,i.on("open",function(){r.emit("open")}),i.on("create",function(e){r.emit("create",e)}),i.on("update",function(e){r.emit("update",e)}),i.on("enter",function(e){r.emit("enter",e)}),i.on("leave",function(e){r.emit("leave",e)}),i.on("delete",function(e){r.emit("delete",e)}),t.resolve()})}),r},unsubscribe:function(e){var t=this;a().then(function(r){t.resolve(r.unsubscribe(e))})},_clearCachedDefaultClient:function(){v=null}}),t.exports=r["default"]},{"./CoreManager":3,"./EventEmitter":4,"./LiveQueryClient":7,"./ParsePromise":20,"babel-runtime/helpers/interop-require-default":56}],18:[function(e,t,r){"use strict";function n(){var e=h["default"].get("SERVER_URL");"/"!==e[e.length-1]&&(e+="/");var t=e.replace(/https?:\/\//,"");return t.substr(t.indexOf("/"))}var a=e("babel-runtime/helpers/create-class")["default"],i=e("babel-runtime/helpers/class-call-check")["default"],s=e("babel-runtime/core-js/object/keys")["default"],o=e("babel-runtime/core-js/object/freeze")["default"],u=e("babel-runtime/core-js/object/create")["default"],l=e("babel-runtime/core-js/object/define-property")["default"],c=e("babel-runtime/helpers/interop-require-default")["default"],f=e("babel-runtime/helpers/interop-require-wildcard")["default"];Object.defineProperty(r,"__esModule",{value:!0});var d=e("./CoreManager"),h=c(d),p=e("./canBeSerialized"),v=c(p),y=e("./decode"),b=c(y),g=e("./encode"),_=c(g),m=e("./equals"),O=(c(m),e("./escape")),C=c(O),k=e("./ParseACL"),w=c(k),S=e("./parseDate"),E=c(S),P=e("./ParseError"),j=c(P),A=e("./ParseFile"),I=c(A),T=e("./ParseOp"),N=e("./ParsePromise"),R=c(N),$=e("./ParseQuery"),M=c($),x=e("./ParseRelation"),D=c(x),L=e("./SingleInstanceStateController"),U=f(L),q=e("./unique"),F=c(q),K=e("./UniqueInstanceStateController"),J=f(K),W=e("./unsavedChildren"),Q=c(W),B={},V=0,G=0,z=!h["default"].get("IS_NODE");z?h["default"].setObjectStateController(U):h["default"].setObjectStateController(J);var Y=function(){function e(t,r,n){i(this,e),"function"==typeof this.initialize&&this.initialize.apply(this,arguments);var a=null;if(this._objCount=G++,"string"==typeof t)this.className=t,r&&"object"==typeof r&&(a=r);else if(t&&"object"==typeof t){this.className=t.className,a={};for(var s in t)"className"!==s&&(a[s]=t[s]);r&&"object"==typeof r&&(n=r)}if(a&&!this.set(a,n))throw new Error("Can't create an invalid Parse Object")}return a(e,[{key:"_getId",value:function(){if("string"==typeof this.id)return this.id;if("string"==typeof this._localId)return this._localId;var e="local"+String(V++);return this._localId=e,e}},{key:"_getStateIdentifier",value:function(){if(z){var e=this.id;return e||(e=this._getId()),{id:e,className:this.className}}return this}},{key:"_getServerData",value:function(){var e=h["default"].getObjectStateController();return e.getServerData(this._getStateIdentifier())}},{key:"_clearServerData",value:function(){var e=this._getServerData(),t={};for(var r in e)t[r]=void 0;var n=h["default"].getObjectStateController();n.setServerData(this._getStateIdentifier(),t)}},{key:"_getPendingOps",value:function(){var e=h["default"].getObjectStateController();return e.getPendingOps(this._getStateIdentifier())}},{key:"_clearPendingOps",value:function(){var e=this._getPendingOps(),t=e[e.length-1],r=s(t);r.forEach(function(e){delete t[e]})}},{key:"_getDirtyObjectAttributes",value:function(){var t=this.attributes,r=h["default"].getObjectStateController(),n=r.getObjectCache(this._getStateIdentifier()),a={};for(var i in t){var s=t[i];if(s&&"object"==typeof s&&!(s instanceof e)&&!(s instanceof I["default"])&&!(s instanceof D["default"]))try{var o=(0,_["default"])(s,!1,!0),u=JSON.stringify(o);n[i]!==u&&(a[i]=s)}catch(l){a[i]=s}}return a}},{key:"_toFullJSON",value:function(e){var t=this.toJSON(e);return t.__type="Object",t.className=this.className,t}},{key:"_getSaveJSON",value:function(){var e,t=this._getPendingOps(),r=this._getDirtyObjectAttributes(),n={};for(e in r)n[e]=new T.SetOp(r[e]).toJSON();for(e in t[0])n[e]=t[0][e].toJSON();return n}},{key:"_getSaveParams",value:function(){var e=this.id?"PUT":"POST",t=this._getSaveJSON(),r="classes/"+this.className;return this.id?r+="/"+this.id:"_User"===this.className&&(r="users"),{method:e,body:t,path:r}}},{key:"_finishFetch",value:function(e){!this.id&&e.objectId&&(this.id=e.objectId);var t=h["default"].getObjectStateController();t.initializeState(this._getStateIdentifier());var r={};for(var n in e)"ACL"===n?r[n]=new w["default"](e[n]):"objectId"!==n&&(r[n]=(0,b["default"])(e[n]),r[n]instanceof D["default"]&&r[n]._ensureParentAndKey(this,n));r.createdAt&&"string"==typeof r.createdAt&&(r.createdAt=(0,E["default"])(r.createdAt)),r.updatedAt&&"string"==typeof r.updatedAt&&(r.updatedAt=(0,E["default"])(r.updatedAt)),!r.updatedAt&&r.createdAt&&(r.updatedAt=r.createdAt),t.commitServerChanges(this._getStateIdentifier(),r)}},{key:"_setExisted",value:function(e){var t=h["default"].getObjectStateController(),r=t.getState(this._getStateIdentifier());r&&(r.existed=e)}},{key:"_migrateId",value:function(e){if(this._localId&&e)if(z){var t=h["default"].getObjectStateController(),r=t.removeState(this._getStateIdentifier());this.id=e,delete this._localId,r&&t.initializeState(this._getStateIdentifier(),r)}else this.id=e,delete this._localId}},{key:"_handleSaveResponse",value:function(e,t){var r,n={},a=h["default"].getObjectStateController(),i=a.popPendingState(this._getStateIdentifier());for(r in i)i[r]instanceof T.RelationOp?n[r]=i[r].applyTo(void 0,this,r):r in e||(n[r]=i[r].applyTo(void 0));for(r in e)"createdAt"!==r&&"updatedAt"!==r||"string"!=typeof e[r]?"ACL"===r?n[r]=new w["default"](e[r]):"objectId"!==r&&(n[r]=(0,b["default"])(e[r]),n[r]instanceof T.UnsetOp&&(n[r]=void 0)):n[r]=(0,E["default"])(e[r]);n.createdAt&&!n.updatedAt&&(n.updatedAt=n.createdAt),this._migrateId(e.objectId),201!==t&&this._setExisted(!0),a.commitServerChanges(this._getStateIdentifier(),n)}},{key:"_handleSaveError",value:function(){var e=(this._getPendingOps(),h["default"].getObjectStateController());e.mergeFirstPendingState(this._getStateIdentifier())}},{key:"initialize",value:function(){}},{key:"toJSON",value:function(e){var t=this.id?this.className+":"+this.id:this,e=e||[t],r={},n=this.attributes;for(var a in n)"createdAt"!==a&&"updatedAt"!==a||!n[a].toJSON?r[a]=(0,_["default"])(n[a],!1,!1,e):r[a]=n[a].toJSON();var i=this._getPendingOps();for(var a in i[0])r[a]=i[0][a].toJSON();return this.id&&(r.objectId=this.id),r}},{key:"equals",value:function(t){return this===t||t instanceof e&&this.className===t.className&&this.id===t.id&&"undefined"!=typeof this.id}},{key:"dirty",value:function(e){if(!this.id)return!0;var t=this._getPendingOps(),r=this._getDirtyObjectAttributes();if(e){if(r.hasOwnProperty(e))return!0;for(var n=0;n<t.length;n++)if(t[n].hasOwnProperty(e))return!0;return!1}return 0!==s(t[0]).length||0!==s(r).length}},{key:"dirtyKeys",value:function(){for(var e=this._getPendingOps(),t={},r=0;r<e.length;r++)for(var n in e[r])t[n]=!0;var a=this._getDirtyObjectAttributes();for(var n in a)t[n]=!0;return s(t)}},{key:"toPointer",value:function(){if(!this.id)throw new Error("Cannot create a pointer to an unsaved ParseObject");return{__type:"Pointer",className:this.className,objectId:this.id}}},{key:"get",value:function(e){return this.attributes[e]}},{key:"relation",value:function(e){var t=this.get(e);if(t){if(!(t instanceof D["default"]))throw new Error("Called relation() on non-relation field "+e);return t._ensureParentAndKey(this,e),t}return new D["default"](this,e)}},{key:"escape",value:function(e){var t=this.attributes[e];if(null==t)return"";if("string"!=typeof t){if("function"!=typeof t.toString)return"";t=t.toString()}return(0,C["default"])(t)}},{key:"has",value:function(e){var t=this.attributes;return!!t.hasOwnProperty(e)&&null!=t[e]}},{key:"set",value:function(e,t,r){var n={},a={};if(e&&"object"==typeof e)n=e,r=t;else{if("string"!=typeof e)return this;n[e]=t}r=r||{};var i=[];"function"==typeof this.constructor.readOnlyAttributes&&(i=i.concat(this.constructor.readOnlyAttributes()));for(var s in n)if("createdAt"!==s&&"updatedAt"!==s){if(i.indexOf(s)>-1)throw new Error("Cannot modify readonly attribute: "+s);r.unset?a[s]=new T.UnsetOp:n[s]instanceof T.Op?a[s]=n[s]:n[s]&&"object"==typeof n[s]&&"string"==typeof n[s].__op?a[s]=(0,T.opFromJSON)(n[s]):"objectId"===s||"id"===s?"string"==typeof n[s]&&(this.id=n[s]):"ACL"!==s||"object"!=typeof n[s]||n[s]instanceof w["default"]?a[s]=new T.SetOp(n[s]):a[s]=new T.SetOp(new w["default"](n[s]))}var o=this.attributes,u={};for(var l in a)a[l]instanceof T.RelationOp?u[l]=a[l].applyTo(o[l],this,l):a[l]instanceof T.UnsetOp||(u[l]=a[l].applyTo(o[l]));if(!r.ignoreValidation){var c=this.validate(u);if(c)return"function"==typeof r.error&&r.error(this,c),!1}var f=this._getPendingOps(),d=f.length-1,p=h["default"].getObjectStateController();for(var l in a){var v=a[l].mergeWith(f[d][l]);p.setPendingOp(this._getStateIdentifier(),l,v)}return this}},{key:"unset",value:function(e,t){return t=t||{},t.unset=!0,this.set(e,null,t)}},{key:"increment",value:function(e,t){if("undefined"==typeof t&&(t=1),"number"!=typeof t)throw new Error("Cannot increment by a non-numeric amount.");return this.set(e,new T.IncrementOp(t))}},{key:"add",value:function(e,t){return this.set(e,new T.AddOp([t]))}},{key:"addUnique",value:function(e,t){return this.set(e,new T.AddUniqueOp([t]))}},{key:"remove",value:function(e,t){return this.set(e,new T.RemoveOp([t]))}},{key:"op",value:function(e){for(var t=this._getPendingOps(),r=t.length;r--;)if(t[r][e])return t[r][e]}},{key:"clone",value:function t(){var t=new this.constructor;t.className||(t.className=this.className);var e=this.attributes;if("function"==typeof this.constructor.readOnlyAttributes){var r=this.constructor.readOnlyAttributes()||[],n={};for(var a in e)r.indexOf(a)<0&&(n[a]=e[a]);e=n}return t.set&&t.set(e),t}},{key:"newInstance",value:function(){var e=new this.constructor;if(e.className||(e.className=this.className),e.id=this.id,z)return e;var t=h["default"].getObjectStateController();return t&&t.duplicateState(this._getStateIdentifier(),e._getStateIdentifier()),e}},{key:"isNew",value:function(){return!this.id}},{key:"existed",value:function(){if(!this.id)return!1;var e=h["default"].getObjectStateController(),t=e.getState(this._getStateIdentifier());return!!t&&t.existed}},{key:"isValid",value:function(){return!this.validate(this.attributes)}},{key:"validate",value:function(e){if(e.hasOwnProperty("ACL")&&!(e.ACL instanceof w["default"]))return new j["default"](j["default"].OTHER_CAUSE,"ACL must be a Parse ACL.");for(var t in e)if(!/^[A-Za-z][0-9A-Za-z_]*$/.test(t))return new j["default"](j["default"].INVALID_KEY_NAME);return!1}},{key:"getACL",value:function(){var e=this.get("ACL");return e instanceof w["default"]?e:null}},{key:"setACL",value:function(e,t){return this.set("ACL",e,t)}},{key:"revert",value:function(){this._clearPendingOps()}},{key:"clear",value:function(){var e=this.attributes,t={},r=["createdAt","updatedAt"];"function"==typeof this.constructor.readOnlyAttributes&&(r=r.concat(this.constructor.readOnlyAttributes()));for(var n in e)r.indexOf(n)<0&&(t[n]=!0);return this.set(t,{unset:!0})}},{key:"fetch",value:function(e){e=e||{};var t={};e.hasOwnProperty("useMasterKey")&&(t.useMasterKey=e.useMasterKey),e.hasOwnProperty("sessionToken")&&(t.sessionToken=e.sessionToken);var r=h["default"].getObjectController();return r.fetch(this,!0,t)._thenRunCallbacks(e)}},{key:"save",value:function(e,t,r){var n,a,i=this;if("object"==typeof e||"undefined"==typeof e?(n=e,"object"==typeof t&&(a=t)):(n={},n[e]=t,a=r),!a&&n&&(a={},"function"==typeof n.success&&(a.success=n.success,delete n.success),"function"==typeof n.error&&(a.error=n.error,delete n.error)),n){var s=this.validate(n);if(s)return a&&"function"==typeof a.error&&a.error(this,s),R["default"].error(s);this.set(n,a)}a=a||{};var o={};a.hasOwnProperty("useMasterKey")&&(o.useMasterKey=!!a.useMasterKey),a.hasOwnProperty("sessionToken")&&"string"==typeof a.sessionToken&&(o.sessionToken=a.sessionToken);var u=h["default"].getObjectController(),l=(0,Q["default"])(this);return u.save(l,o).then(function(){return u.save(i,o)})._thenRunCallbacks(a,this)}},{key:"destroy",value:function(e){e=e||{};var t={};return e.hasOwnProperty("useMasterKey")&&(t.useMasterKey=e.useMasterKey),e.hasOwnProperty("sessionToken")&&(t.sessionToken=e.sessionToken),this.id?h["default"].getObjectController().destroy(this,t)._thenRunCallbacks(e):R["default"].as()._thenRunCallbacks(e)}},{key:"attributes",get:function(){var e=h["default"].getObjectStateController();return o(e.estimateAttributes(this._getStateIdentifier()))}},{key:"createdAt",get:function(){return this._getServerData().createdAt}},{key:"updatedAt",get:function(){return this._getServerData().updatedAt}}],[{key:"_clearAllState",value:function(){var e=h["default"].getObjectStateController();e.clearAllState()}},{key:"fetchAll",value:function(e,t){var t=t||{},r={};return t.hasOwnProperty("useMasterKey")&&(r.useMasterKey=t.useMasterKey),t.hasOwnProperty("sessionToken")&&(r.sessionToken=t.sessionToken),h["default"].getObjectController().fetch(e,!0,r)._thenRunCallbacks(t)}},{key:"fetchAllIfNeeded",value:function(e,t){var t=t||{},r={};return t.hasOwnProperty("useMasterKey")&&(r.useMasterKey=t.useMasterKey),t.hasOwnProperty("sessionToken")&&(r.sessionToken=t.sessionToken),h["default"].getObjectController().fetch(e,!1,r)._thenRunCallbacks(t)}},{key:"destroyAll",value:function(e,t){var t=t||{},r={};return t.hasOwnProperty("useMasterKey")&&(r.useMasterKey=t.useMasterKey),t.hasOwnProperty("sessionToken")&&(r.sessionToken=t.sessionToken),h["default"].getObjectController().destroy(e,r)._thenRunCallbacks(t)}},{key:"saveAll",value:function(e,t){var t=t||{},r={};return t.hasOwnProperty("useMasterKey")&&(r.useMasterKey=t.useMasterKey),t.hasOwnProperty("sessionToken")&&(r.sessionToken=t.sessionToken),h["default"].getObjectController().save(e,r)._thenRunCallbacks(t)}},{key:"createWithoutData",value:function(e){var t=new this;return t.id=e,t}},{key:"fromJSON",value:function(t,r){if(!t.className)throw new Error("Cannot create an object without a className");var n=B[t.className],a=n?new n:new e(t.className),i={};for(var s in t)"className"!==s&&"__type"!==s&&(i[s]=t[s]);if(r){i.objectId&&(a.id=i.objectId);var o=null;"function"==typeof a._preserveFieldsOnFetch&&(o=a._preserveFieldsOnFetch()),a._clearServerData(),o&&a._finishFetch(o)}return a._finishFetch(i),t.objectId&&a._setExisted(!0),a}},{key:"registerSubclass",value:function(e,t){if("string"!=typeof e)throw new TypeError("The first argument must be a valid class name.");if("undefined"==typeof t)throw new TypeError("You must supply a subclass constructor.");if("function"!=typeof t)throw new TypeError("You must register the subclass constructor. Did you attempt to register an instance of the subclass?");B[e]=t,t.className||(t.className=e)}},{key:"extend",value:function(t,r,n){if("string"!=typeof t){if(t&&"string"==typeof t.className)return e.extend(t.className,t,r);throw new Error("Parse.Object.extend's first argument should be the className.")}var a=t;"User"===a&&h["default"].get("PERFORM_USER_REWRITE")&&(a="_User");var i=e.prototype;this.hasOwnProperty("__super__")&&this.__super__?i=this.prototype:B[a]&&(i=B[a].prototype);var s=function(e,t){if(this.className=a,this._objCount=G++,"function"==typeof this.initialize&&this.initialize.apply(this,arguments),e&&"object"==typeof e&&!this.set(e||{},t))throw new Error("Can't create an invalid Parse Object")};if(s.className=a,s.__super__=i,s.prototype=u(i,{constructor:{value:s,enumerable:!1,writable:!0,configurable:!0}}),r)for(var o in r)"className"!==o&&l(s.prototype,o,{value:r[o],enumerable:!1,writable:!0,configurable:!0});if(n)for(var o in n)"className"!==o&&l(s,o,{value:n[o],enumerable:!1,writable:!0,configurable:!0});return s.extend=function(t,r,n){return"string"==typeof t?e.extend.call(s,t,r,n):e.extend.call(s,a,t,r)},s.createWithoutData=e.createWithoutData,B[a]=s,s}},{key:"enableSingleInstance",value:function(){z=!0,h["default"].setObjectStateController(U)}},{key:"disableSingleInstance",value:function(){z=!1,h["default"].setObjectStateController(J)}}]),e}();r["default"]=Y,h["default"].setObjectController({fetch:function(e,t,r){if(Array.isArray(e)){if(e.length<1)return R["default"].as([]);var n=[],a=[],i=null,o=[],u=null;if(e.forEach(function(e,r){u||(i||(i=e.className),i!==e.className&&(u=new j["default"](j["default"].INVALID_CLASS_NAME,"All objects should be of the same class")),e.id||(u=new j["default"](j["default"].MISSING_OBJECT_ID,"All objects must have an ID")),(t||0===s(e._getServerData()).length)&&(a.push(e.id),n.push(e)),o.push(e))}),u)return R["default"].error(u);var l=new M["default"](i);return l.containedIn("objectId",a),l._limit=a.length,l.find(r).then(function(e){var r={};e.forEach(function(e){r[e.id]=e});for(var a=0;a<n.length;a++){var i=n[a];if((!i||!i.id||!r[i.id])&&t)return R["default"].error(new j["default"](j["default"].OBJECT_NOT_FOUND,"All objects must exist on the server."))}if(!z)for(var a=0;a<o.length;a++){var i=o[a];if(i&&i.id&&r[i.id]){var s=i.id;i._finishFetch(r[s].toJSON()),o[a]=r[s]}}return R["default"].as(o)})}var c=h["default"].getRESTController();return c.request("GET","classes/"+e.className+"/"+e._getId(),{},r).then(function(t,r,n){return e instanceof Y&&(e._clearPendingOps(),e._clearServerData(),e._finishFetch(t)),e})},destroy:function(e,t){var r=h["default"].getRESTController();if(Array.isArray(e)){if(e.length<1)return R["default"].as([]);var a=[[]];e.forEach(function(e){e.id&&(a[a.length-1].push(e),a[a.length-1].length>=20&&a.push([]))}),0===a[a.length-1].length&&a.pop();var i=R["default"].as(),s=[];return a.forEach(function(e){i=i.then(function(){return r.request("POST","batch",{requests:e.map(function(e){return{method:"DELETE",path:n()+"classes/"+e.className+"/"+e._getId(),body:{}}})},t).then(function(t){for(var r=0;r<t.length;r++)if(t[r]&&t[r].hasOwnProperty("error")){var n=new j["default"](t[r].error.code,t[r].error.error);n.object=e[r],s.push(n)}})})}),i.then(function(){if(s.length){var t=new j["default"](j["default"].AGGREGATE_ERROR);return t.errors=s,R["default"].error(t)}return R["default"].as(e)})}return e instanceof Y?r.request("DELETE","classes/"+e.className+"/"+e._getId(),{},t).then(function(){return R["default"].as(e)}):R["default"].as(e)},save:function(e,t){var r=h["default"].getRESTController(),a=h["default"].getObjectStateController();if(Array.isArray(e)){if(e.length<1)return R["default"].as([]);for(var i=e.concat(),s=0;s<e.length;s++)e[s]instanceof Y&&(i=i.concat((0,Q["default"])(e[s],!0)));i=(0,F["default"])(i);var o=R["default"].as(),u=[];return i.forEach(function(e){e instanceof I["default"]?o=o.then(function(){return e.save()}):e instanceof Y&&u.push(e)}),o.then(function(){var i=null;return R["default"]._continueWhile(function(){return u.length>0},function(){var e=[],s=[];if(u.forEach(function(t){e.length<20&&(0,v["default"])(t)?e.push(t):s.push(t)}),u=s,e.length<1)return R["default"].error(new j["default"](j["default"].OTHER_CAUSE,"Tried to save a batch with a cycle."));var o=new R["default"],l=[],c=[];return e.forEach(function(e,t){var r=new R["default"];l.push(r);var n=function(){return r.resolve(),o.then(function(r,n){if(r[t].hasOwnProperty("success"))e._handleSaveResponse(r[t].success,n);else{if(!i&&r[t].hasOwnProperty("error")){var a=r[t].error;i=new j["default"](a.code,a.error),u=[]}e._handleSaveError()}})};a.pushPendingState(e._getStateIdentifier()),c.push(a.enqueueTask(e._getStateIdentifier(),n))}),R["default"].when(l).then(function(){return r.request("POST","batch",{requests:e.map(function(e){var t=e._getSaveParams();return t.path=n()+t.path,t})},t)}).then(function(e,t,r){o.resolve(e,t)}),R["default"].when(c)}).then(function(){return i?R["default"].error(i):R["default"].as(e)})})}if(e instanceof Y){var l=e,c=function(){var e=l._getSaveParams();return r.request(e.method,e.path,e.body,t).then(function(e,t){l._handleSaveResponse(e,t)},function(e){return l._handleSaveError(),R["default"].error(e)})};return a.pushPendingState(e._getStateIdentifier()),a.enqueueTask(e._getStateIdentifier(),c).then(function(){return e},function(e){return R["default"].error(e)})}return R["default"].as()}}),t.exports=r["default"]},{"./CoreManager":3,"./ParseACL":11,"./ParseError":13,"./ParseFile":14,"./ParseOp":19,"./ParsePromise":20,"./ParseQuery":21,"./ParseRelation":22,"./SingleInstanceStateController":28,"./UniqueInstanceStateController":32,"./canBeSerialized":34,"./decode":35,"./encode":36,"./equals":37,"./escape":38,"./parseDate":40,"./unique":41,"./unsavedChildren":42,"babel-runtime/core-js/object/create":45,"babel-runtime/core-js/object/define-property":46,"babel-runtime/core-js/object/freeze":47,"babel-runtime/core-js/object/keys":49,"babel-runtime/helpers/class-call-check":52,"babel-runtime/helpers/create-class":53,"babel-runtime/helpers/interop-require-default":56,"babel-runtime/helpers/interop-require-wildcard":57}],19:[function(e,t,r){"use strict";function n(e){if(!e||!e.__op)return null;switch(e.__op){case"Delete":return new k;case"Increment":return new w(e.amount);case"Add":return new S((0,d["default"])(e.objects));case"AddUnique":return new E((0,d["default"])(e.objects));case"Remove":return new P((0,d["default"])(e.objects));case"AddRelation":var t=(0,d["default"])(e.objects);return Array.isArray(t)?new j(t,[]):new j([],[]);case"RemoveRelation":var r=(0,d["default"])(e.objects);return Array.isArray(r)?new j([],r):new j([],[]);case"Batch":for(var t=[],r=[],n=0;n<e.ops.length;n++)"AddRelation"===e.ops[n].__op?t=t.concat((0,d["default"])(e.ops[n].objects)):"RemoveRelation"===e.ops[n].__op&&(r=r.concat((0,d["default"])(e.ops[n].objects)));return new j(t,r)}return null}var a=e("babel-runtime/helpers/create-class")["default"],i=e("babel-runtime/helpers/class-call-check")["default"],s=e("babel-runtime/helpers/get")["default"],o=e("babel-runtime/helpers/inherits")["default"],u=e("babel-runtime/helpers/interop-require-default")["default"];Object.defineProperty(r,"__esModule",{value:!0}),r.opFromJSON=n;var l=e("./arrayContainsObject"),c=u(l),f=e("./decode"),d=u(f),h=e("./encode"),p=u(h),v=e("./ParseObject"),y=u(v),b=e("./ParseRelation"),g=u(b),_=e("./unique"),m=u(_),O=function(){function e(){i(this,e)}return a(e,[{key:"applyTo",value:function(e){}},{key:"mergeWith",value:function(e){}},{key:"toJSON",value:function(){}}]),e}();r.Op=O;var C=function(e){function t(e){i(this,t),s(Object.getPrototypeOf(t.prototype),"constructor",this).call(this),this._value=e}return o(t,e),a(t,[{key:"applyTo",value:function(e){return this._value}},{key:"mergeWith",value:function(e){return new t(this._value)}},{key:"toJSON",value:function(){return(0,p["default"])(this._value,!1,!0)}}]),t}(O);r.SetOp=C;var k=function(e){function t(){i(this,t),s(Object.getPrototypeOf(t.prototype),"constructor",this).apply(this,arguments)}return o(t,e),a(t,[{key:"applyTo",value:function(e){}},{key:"mergeWith",value:function(e){return new t}},{key:"toJSON",value:function(){return{__op:"Delete"}}}]),t}(O);r.UnsetOp=k;var w=function(e){function t(e){if(i(this,t),s(Object.getPrototypeOf(t.prototype),"constructor",this).call(this),"number"!=typeof e)throw new TypeError("Increment Op must be initialized with a numeric amount.");this._amount=e}return o(t,e),a(t,[{key:"applyTo",value:function(e){if("undefined"==typeof e)return this._amount;if("number"!=typeof e)throw new TypeError("Cannot increment a non-numeric value.");return this._amount+e}},{key:"mergeWith",value:function(e){if(!e)return this;if(e instanceof C)return new C(this.applyTo(e._value));if(e instanceof k)return new C(this._amount);if(e instanceof t)return new t(this.applyTo(e._amount));throw new Error("Cannot merge Increment Op with the previous Op")}},{key:"toJSON",value:function(){return{__op:"Increment",amount:this._amount}}}]),t}(O);r.IncrementOp=w;var S=function(e){function t(e){i(this,t),s(Object.getPrototypeOf(t.prototype),"constructor",this).call(this),this._value=Array.isArray(e)?e:[e]}return o(t,e),a(t,[{key:"applyTo",value:function(e){if(null==e)return this._value;if(Array.isArray(e))return e.concat(this._value);throw new Error("Cannot add elements to a non-array value")}},{key:"mergeWith",value:function(e){if(!e)return this;if(e instanceof C)return new C(this.applyTo(e._value));if(e instanceof k)return new C(this._value);if(e instanceof t)return new t(this.applyTo(e._value));throw new Error("Cannot merge Add Op with the previous Op")}},{key:"toJSON",value:function(){return{__op:"Add",objects:(0,p["default"])(this._value,!1,!0)}}}]),t}(O);r.AddOp=S;var E=function(e){function t(e){i(this,t),s(Object.getPrototypeOf(t.prototype),"constructor",this).call(this),this._value=(0,m["default"])(Array.isArray(e)?e:[e])}return o(t,e),a(t,[{key:"applyTo",value:function(e){if(null==e)return this._value||[];if(Array.isArray(e)){var t=e,r=[];return this._value.forEach(function(e){e instanceof y["default"]?(0,c["default"])(t,e)||r.push(e):t.indexOf(e)<0&&r.push(e)}),e.concat(r)}throw new Error("Cannot add elements to a non-array value")}},{key:"mergeWith",value:function(e){if(!e)return this;if(e instanceof C)return new C(this.applyTo(e._value));if(e instanceof k)return new C(this._value);if(e instanceof t)return new t(this.applyTo(e._value));
throw new Error("Cannot merge AddUnique Op with the previous Op")}},{key:"toJSON",value:function(){return{__op:"AddUnique",objects:(0,p["default"])(this._value,!1,!0)}}}]),t}(O);r.AddUniqueOp=E;var P=function(e){function t(e){i(this,t),s(Object.getPrototypeOf(t.prototype),"constructor",this).call(this),this._value=(0,m["default"])(Array.isArray(e)?e:[e])}return o(t,e),a(t,[{key:"applyTo",value:function(e){if(null==e)return[];if(Array.isArray(e)){for(var t=e.indexOf(this._value),r=e.concat([]),t=0;t<this._value.length;t++){for(var n=r.indexOf(this._value[t]);n>-1;)r.splice(n,1),n=r.indexOf(this._value[t]);if(this._value[t]instanceof y["default"]&&this._value[t].id)for(var a=0;a<r.length;a++)r[a]instanceof y["default"]&&this._value[t].id===r[a].id&&(r.splice(a,1),a--)}return r}throw new Error("Cannot remove elements from a non-array value")}},{key:"mergeWith",value:function(e){if(!e)return this;if(e instanceof C)return new C(this.applyTo(e._value));if(e instanceof k)return new k;if(e instanceof t){for(var r=e._value.concat([]),n=0;n<this._value.length;n++)this._value[n]instanceof y["default"]?(0,c["default"])(r,this._value[n])||r.push(this._value[n]):r.indexOf(this._value[n])<0&&r.push(this._value[n]);return new t(r)}throw new Error("Cannot merge Remove Op with the previous Op")}},{key:"toJSON",value:function(){return{__op:"Remove",objects:(0,p["default"])(this._value,!1,!0)}}}]),t}(O);r.RemoveOp=P;var j=function(e){function t(e,r){i(this,t),s(Object.getPrototypeOf(t.prototype),"constructor",this).call(this),this._targetClassName=null,Array.isArray(e)&&(this.relationsToAdd=(0,m["default"])(e.map(this._extractId,this))),Array.isArray(r)&&(this.relationsToRemove=(0,m["default"])(r.map(this._extractId,this)))}return o(t,e),a(t,[{key:"_extractId",value:function(e){if("string"==typeof e)return e;if(!e.id)throw new Error("You cannot add or remove an unsaved Parse Object from a relation");if(this._targetClassName||(this._targetClassName=e.className),this._targetClassName!==e.className)throw new Error("Tried to create a Relation with 2 different object types: "+this._targetClassName+" and "+e.className+".");return e.id}},{key:"applyTo",value:function(e,t,r){if(!e){if(!t||!r)throw new Error("Cannot apply a RelationOp without either a previous value, or an object and a key");var n=new y["default"](t.className);t.id&&0===t.id.indexOf("local")?n._localId=t.id:t.id&&(n.id=t.id);var a=new g["default"](n,r);return a.targetClassName=this._targetClassName,a}if(e instanceof g["default"]){if(this._targetClassName)if(e.targetClassName){if(this._targetClassName!==e.targetClassName)throw new Error("Related object must be a "+e.targetClassName+", but a "+this._targetClassName+" was passed in.")}else e.targetClassName=this._targetClassName;return e}throw new Error("Relation cannot be applied to a non-relation field")}},{key:"mergeWith",value:function(e){if(!e)return this;if(e instanceof k)throw new Error("You cannot modify a relation after deleting it.");if(e instanceof t){if(e._targetClassName&&e._targetClassName!==this._targetClassName)throw new Error("Related object must be of class "+e._targetClassName+", but "+(this._targetClassName||"null")+" was passed in.");var r=e.relationsToAdd.concat([]);this.relationsToRemove.forEach(function(e){var t=r.indexOf(e);t>-1&&r.splice(t,1)}),this.relationsToAdd.forEach(function(e){var t=r.indexOf(e);t<0&&r.push(e)});var n=e.relationsToRemove.concat([]);this.relationsToAdd.forEach(function(e){var t=n.indexOf(e);t>-1&&n.splice(t,1)}),this.relationsToRemove.forEach(function(e){var t=n.indexOf(e);t<0&&n.push(e)});var a=new t(r,n);return a._targetClassName=this._targetClassName,a}throw new Error("Cannot merge Relation Op with the previous Op")}},{key:"toJSON",value:function(){var e=this,t=function(t){return{__type:"Pointer",className:e._targetClassName,objectId:t}},r=null,n=null,a=null;return this.relationsToAdd.length>0&&(a=this.relationsToAdd.map(t),r={__op:"AddRelation",objects:a}),this.relationsToRemove.length>0&&(a=this.relationsToRemove.map(t),n={__op:"RemoveRelation",objects:a}),r&&n?{__op:"Batch",ops:[r,n]}:r||n||{}}}]),t}(O);r.RelationOp=j},{"./ParseObject":18,"./ParseRelation":22,"./arrayContainsObject":33,"./decode":35,"./encode":36,"./unique":41,"babel-runtime/helpers/class-call-check":52,"babel-runtime/helpers/create-class":53,"babel-runtime/helpers/get":54,"babel-runtime/helpers/inherits":55,"babel-runtime/helpers/interop-require-default":56}],20:[function(e,t,r){(function(n){"use strict";var a=e("babel-runtime/helpers/create-class")["default"],i=e("babel-runtime/helpers/class-call-check")["default"],s=e("babel-runtime/core-js/get-iterator")["default"];Object.defineProperty(r,"__esModule",{value:!0});var o=!0,u=function(){function e(t){i(this,e),this._resolved=!1,this._rejected=!1,this._resolvedCallbacks=[],this._rejectedCallbacks=[],"function"==typeof t&&t(this.resolve.bind(this),this.reject.bind(this))}return a(e,[{key:"resolve",value:function(){if(this._resolved||this._rejected)throw new Error("A promise was resolved even though it had already been "+(this._resolved?"resolved":"rejected")+".");this._resolved=!0;for(var e=arguments.length,t=Array(e),r=0;r<e;r++)t[r]=arguments[r];this._result=t;for(var n=0;n<this._resolvedCallbacks.length;n++)this._resolvedCallbacks[n].apply(this,t);this._resolvedCallbacks=[],this._rejectedCallbacks=[]}},{key:"reject",value:function(e){if(this._resolved||this._rejected)throw new Error("A promise was rejected even though it had already been "+(this._resolved?"resolved":"rejected")+".");this._rejected=!0,this._error=e;for(var t=0;t<this._rejectedCallbacks.length;t++)this._rejectedCallbacks[t](e);this._resolvedCallbacks=[],this._rejectedCallbacks=[]}},{key:"then",value:function(t,r){var a=this,i=new e,s=function(){for(var r=arguments.length,n=Array(r),a=0;a<r;a++)n[a]=arguments[a];if("function"==typeof t)if(o)try{n=[t.apply(this,n)]}catch(s){n=[e.error(s)]}else n=[t.apply(this,n)];1===n.length&&e.is(n[0])?n[0].then(function(){i.resolve.apply(i,arguments)},function(e){i.reject(e)}):i.resolve.apply(i,n)},u=function(t){var n=[];if("function"==typeof r){if(o)try{n=[r(t)]}catch(a){n=[e.error(a)]}else n=[r(t)];1===n.length&&e.is(n[0])?n[0].then(function(){i.resolve.apply(i,arguments)},function(e){i.reject(e)}):o?i.resolve.apply(i,n):i.reject(n[0])}else i.reject(t)},l=function(e){e.call()};return o&&("undefined"!=typeof n&&"function"==typeof n.nextTick?l=function(e){n.nextTick(e)}:"function"==typeof setTimeout&&(l=function(e){setTimeout(e,0)})),this._resolved?l(function(){s.apply(a,a._result)}):this._rejected?l(function(){u(a._error)}):(this._resolvedCallbacks.push(s),this._rejectedCallbacks.push(u)),i}},{key:"always",value:function(e){return this.then(e,e)}},{key:"done",value:function(e){return this.then(e)}},{key:"fail",value:function(e){return this.then(null,e)}},{key:"catch",value:function(e){return this.then(null,e)}},{key:"_thenRunCallbacks",value:function(t,r){var n={};return"function"==typeof t?(n.success=function(e){t(e,null)},n.error=function(e){t(null,e)}):"object"==typeof t&&("function"==typeof t.success&&(n.success=t.success),"function"==typeof t.error&&(n.error=t.error)),this.then(function(){for(var t=arguments.length,r=Array(t),a=0;a<t;a++)r[a]=arguments[a];return n.success&&n.success.apply(this,r),e.as.apply(e,arguments)},function(t){return n.error&&("undefined"!=typeof r?n.error(r,t):n.error(t)),e.error(t)})}},{key:"_continueWith",value:function(e){return this.then(function(){return e(arguments,null)},function(t){return e(null,t)})}}],[{key:"is",value:function(e){return null!=e&&"function"==typeof e.then}},{key:"as",value:function(){for(var t=new e,r=arguments.length,n=Array(r),a=0;a<r;a++)n[a]=arguments[a];return t.resolve.apply(t,n),t}},{key:"resolve",value:function(t){return new e(function(r,n){e.is(t)?t.then(r,n):r(t)})}},{key:"error",value:function(){for(var t=new e,r=arguments.length,n=Array(r),a=0;a<r;a++)n[a]=arguments[a];return t.reject.apply(t,n),t}},{key:"reject",value:function(){for(var t=arguments.length,r=Array(t),n=0;n<t;n++)r[n]=arguments[n];return e.error.apply(null,r)}},{key:"when",value:function(t){var r,n=Array.isArray(t);r=n?t:arguments;var a=r.length,i=!1,s=[],o=n?[s]:s,u=[];if(s.length=r.length,u.length=r.length,0===a)return e.as.apply(this,o);for(var l=new e,c=function(){a--,a<=0&&(i?l.reject(u):l.resolve.apply(l,o))},f=function(t,r){e.is(t)?t.then(function(e){s[r]=e,c()},function(e){u[r]=e,i=!0,c()}):(s[d]=t,c())},d=0;d<r.length;d++)f(r[d],d);return l}},{key:"all",value:function(t){var r=0,n=[],a=!0,i=!1,o=void 0;try{for(var u,l=s(t);!(a=(u=l.next()).done);a=!0){var c=u.value;n[r++]=c}}catch(f){i=!0,o=f}finally{try{!a&&l["return"]&&l["return"]()}finally{if(i)throw o}}if(0===r)return e.as([]);var d=!1,h=new e,p=0,v=[];return n.forEach(function(t,n){e.is(t)?t.then(function(e){return!d&&(v[n]=e,p++,void(p>=r&&h.resolve(v)))},function(e){h.reject(e),d=!0}):(v[n]=t,p++,!d&&p>=r&&h.resolve(v))}),h}},{key:"race",value:function(t){var r=!1,n=new e,a=!0,i=!1,o=void 0;try{for(var u,l=s(t);!(a=(u=l.next()).done);a=!0){var c=u.value;e.is(c)?c.then(function(e){r||(r=!0,n.resolve(e))},function(e){r||(r=!0,n.reject(e))}):r||(r=!0,n.resolve(c))}}catch(f){i=!0,o=f}finally{try{!a&&l["return"]&&l["return"]()}finally{if(i)throw o}}return n}},{key:"_continueWhile",value:function(t,r){return t()?r().then(function(){return e._continueWhile(t,r)}):e.as()}},{key:"isPromisesAPlusCompliant",value:function(){return o}},{key:"enableAPlusCompliant",value:function(){o=!0}},{key:"disableAPlusCompliant",value:function(){o=!1}}]),e}();r["default"]=u,t.exports=r["default"]}).call(this,e("_process"))},{_process:58,"babel-runtime/core-js/get-iterator":43,"babel-runtime/helpers/class-call-check":52,"babel-runtime/helpers/create-class":53}],21:[function(e,t,r){"use strict";function n(e){return"\\Q"+e.replace("\\E","\\E\\\\E\\Q")+"\\E"}var a=e("babel-runtime/helpers/create-class")["default"],i=e("babel-runtime/helpers/class-call-check")["default"],s=e("babel-runtime/helpers/interop-require-default")["default"];Object.defineProperty(r,"__esModule",{value:!0});var o=e("./CoreManager"),u=s(o),l=e("./encode"),c=s(l),f=e("./ParseError"),d=s(f),h=e("./ParseGeoPoint"),p=s(h),v=e("./ParseObject"),y=s(v),b=e("./ParsePromise"),g=s(b),_=function(){function e(t){if(i(this,e),"string"==typeof t)"User"===t&&u["default"].get("PERFORM_USER_REWRITE")?this.className="_User":this.className=t;else if(t instanceof y["default"])this.className=t.className;else{if("function"!=typeof t)throw new TypeError("A ParseQuery must be constructed with a ParseObject or class name.");if("string"==typeof t.className)this.className=t.className;else{var r=new t;this.className=r.className}}this._where={},this._include=[],this._limit=-1,this._skip=0,this._extraOptions={}}return a(e,[{key:"_orQuery",value:function(e){var t=e.map(function(e){return e.toJSON().where});return this._where.$or=t,this}},{key:"_addCondition",value:function(e,t,r){return this._where[e]&&"string"!=typeof this._where[e]||(this._where[e]={}),this._where[e][t]=(0,c["default"])(r,!1,!0),this}},{key:"toJSON",value:function(){var e={where:this._where};this._include.length&&(e.include=this._include.join(",")),this._select&&(e.keys=this._select.join(",")),this._limit>=0&&(e.limit=this._limit),this._skip>0&&(e.skip=this._skip),this._order&&(e.order=this._order.join(","));for(var t in this._extraOptions)e[t]=this._extraOptions[t];return e}},{key:"get",value:function(e,t){this.equalTo("objectId",e);var r={};return t&&t.hasOwnProperty("useMasterKey")&&(r.useMasterKey=t.useMasterKey),t&&t.hasOwnProperty("sessionToken")&&(r.sessionToken=t.sessionToken),this.first(r).then(function(e){if(e)return e;var t=new d["default"](d["default"].OBJECT_NOT_FOUND,"Object not found.");return g["default"].error(t)})._thenRunCallbacks(t,null)}},{key:"find",value:function(e){var t=this;e=e||{};var r={};e.hasOwnProperty("useMasterKey")&&(r.useMasterKey=e.useMasterKey),e.hasOwnProperty("sessionToken")&&(r.sessionToken=e.sessionToken);var n=u["default"].getQueryController();return n.find(this.className,this.toJSON(),r).then(function(e){return e.results.map(function(r){var n=e.className||t.className;return r.className||(r.className=n),y["default"].fromJSON(r,!0)})})._thenRunCallbacks(e)}},{key:"count",value:function(e){e=e||{};var t={};e.hasOwnProperty("useMasterKey")&&(t.useMasterKey=e.useMasterKey),e.hasOwnProperty("sessionToken")&&(t.sessionToken=e.sessionToken);var r=u["default"].getQueryController(),n=this.toJSON();return n.limit=0,n.count=1,r.find(this.className,n,t).then(function(e){return e.count})._thenRunCallbacks(e)}},{key:"first",value:function(e){var t=this;e=e||{};var r={};e.hasOwnProperty("useMasterKey")&&(r.useMasterKey=e.useMasterKey),e.hasOwnProperty("sessionToken")&&(r.sessionToken=e.sessionToken);var n=u["default"].getQueryController(),a=this.toJSON();return a.limit=1,n.find(this.className,a,r).then(function(e){var r=e.results;if(r[0])return r[0].className||(r[0].className=t.className),y["default"].fromJSON(r[0],!0)})._thenRunCallbacks(e)}},{key:"each",value:function(t,r){if(r=r||{},this._order||this._skip||this._limit>=0)return g["default"].error("Cannot iterate on a query with sort, skip, or limit.")._thenRunCallbacks(r);var n=(new g["default"],new e(this.className));n._limit=r.batchSize||100,n._include=this._include.map(function(e){return e}),this._select&&(n._select=this._select.map(function(e){return e})),n._where={};for(var a in this._where){var i=this._where[a];if(Array.isArray(i))n._where[a]=i.map(function(e){return e});else if(i&&"object"==typeof i){var s={};n._where[a]=s;for(var o in i)s[o]=i[o]}else n._where[a]=i}n.ascending("objectId");var u={};r.hasOwnProperty("useMasterKey")&&(u.useMasterKey=r.useMasterKey),r.hasOwnProperty("sessionToken")&&(u.sessionToken=r.sessionToken);var l=!1;return g["default"]._continueWhile(function(){return!l},function(){return n.find(u).then(function(e){var r=g["default"].as();return e.forEach(function(e){r=r.then(function(){return t(e)})}),r.then(function(){e.length>=n._limit?n.greaterThan("objectId",e[e.length-1].id):l=!0})})})._thenRunCallbacks(r)}},{key:"equalTo",value:function(e,t){return"undefined"==typeof t?this.doesNotExist(e):(this._where[e]=(0,c["default"])(t,!1,!0),this)}},{key:"notEqualTo",value:function(e,t){return this._addCondition(e,"$ne",t)}},{key:"lessThan",value:function(e,t){return this._addCondition(e,"$lt",t)}},{key:"greaterThan",value:function(e,t){return this._addCondition(e,"$gt",t)}},{key:"lessThanOrEqualTo",value:function(e,t){return this._addCondition(e,"$lte",t)}},{key:"greaterThanOrEqualTo",value:function(e,t){return this._addCondition(e,"$gte",t)}},{key:"containedIn",value:function(e,t){return this._addCondition(e,"$in",t)}},{key:"notContainedIn",value:function(e,t){return this._addCondition(e,"$nin",t)}},{key:"containsAll",value:function(e,t){return this._addCondition(e,"$all",t)}},{key:"exists",value:function(e){return this._addCondition(e,"$exists",!0)}},{key:"doesNotExist",value:function(e){return this._addCondition(e,"$exists",!1)}},{key:"matches",value:function(e,t,r){return this._addCondition(e,"$regex",t),r||(r=""),t.ignoreCase&&(r+="i"),t.multiline&&(r+="m"),r.length&&this._addCondition(e,"$options",r),this}},{key:"matchesQuery",value:function(e,t){var r=t.toJSON();return r.className=t.className,this._addCondition(e,"$inQuery",r)}},{key:"doesNotMatchQuery",value:function(e,t){var r=t.toJSON();return r.className=t.className,this._addCondition(e,"$notInQuery",r)}},{key:"matchesKeyInQuery",value:function(e,t,r){var n=r.toJSON();return n.className=r.className,this._addCondition(e,"$select",{key:t,query:n})}},{key:"doesNotMatchKeyInQuery",value:function(e,t,r){var n=r.toJSON();return n.className=r.className,this._addCondition(e,"$dontSelect",{key:t,query:n})}},{key:"contains",value:function(e,t){if("string"!=typeof t)throw new Error("The value being searched for must be a string.");return this._addCondition(e,"$regex",n(t))}},{key:"startsWith",value:function(e,t){if("string"!=typeof t)throw new Error("The value being searched for must be a string.");return this._addCondition(e,"$regex","^"+n(t))}},{key:"endsWith",value:function(e,t){if("string"!=typeof t)throw new Error("The value being searched for must be a string.");return this._addCondition(e,"$regex",n(t)+"$")}},{key:"near",value:function(e,t){return t instanceof p["default"]||(t=new p["default"](t)),this._addCondition(e,"$nearSphere",t)}},{key:"withinRadians",value:function(e,t,r){return this.near(e,t),this._addCondition(e,"$maxDistance",r)}},{key:"withinMiles",value:function(e,t,r){return this.withinRadians(e,t,r/3958.8)}},{key:"withinKilometers",value:function(e,t,r){return this.withinRadians(e,t,r/6371)}},{key:"withinGeoBox",value:function(e,t,r){return t instanceof p["default"]||(t=new p["default"](t)),r instanceof p["default"]||(r=new p["default"](r)),this._addCondition(e,"$within",{$box:[t,r]}),this}},{key:"ascending",value:function(){this._order=[];for(var e=arguments.length,t=Array(e),r=0;r<e;r++)t[r]=arguments[r];return this.addAscending.apply(this,t)}},{key:"addAscending",value:function(){var e=this;this._order||(this._order=[]);for(var t=arguments.length,r=Array(t),n=0;n<t;n++)r[n]=arguments[n];return r.forEach(function(t){Array.isArray(t)&&(t=t.join()),e._order=e._order.concat(t.replace(/\s/g,"").split(","))}),this}},{key:"descending",value:function(){this._order=[];for(var e=arguments.length,t=Array(e),r=0;r<e;r++)t[r]=arguments[r];return this.addDescending.apply(this,t)}},{key:"addDescending",value:function(){var e=this;this._order||(this._order=[]);for(var t=arguments.length,r=Array(t),n=0;n<t;n++)r[n]=arguments[n];return r.forEach(function(t){Array.isArray(t)&&(t=t.join()),e._order=e._order.concat(t.replace(/\s/g,"").split(",").map(function(e){return"-"+e}))}),this}},{key:"skip",value:function(e){if("number"!=typeof e||e<0)throw new Error("You can only skip by a positive number");return this._skip=e,this}},{key:"limit",value:function(e){if("number"!=typeof e)throw new Error("You can only set the limit to a numeric value");return this._limit=e,this}},{key:"include",value:function(){for(var e=this,t=arguments.length,r=Array(t),n=0;n<t;n++)r[n]=arguments[n];return r.forEach(function(t){Array.isArray(t)?e._include=e._include.concat(t):e._include.push(t)}),this}},{key:"select",value:function(){var e=this;this._select||(this._select=[]);for(var t=arguments.length,r=Array(t),n=0;n<t;n++)r[n]=arguments[n];return r.forEach(function(t){Array.isArray(t)?e._select=e._select.concat(t):e._select.push(t)}),this}},{key:"subscribe",value:function(){var e=u["default"].getLiveQueryController();return e.subscribe(this)}}],[{key:"or",value:function(){for(var t=null,r=arguments.length,n=Array(r),a=0;a<r;a++)n[a]=arguments[a];n.forEach(function(e){if(t||(t=e.className),t!==e.className)throw new Error("All queries must be for the same class.")});var i=new e(t);return i._orQuery(n),i}}]),e}();r["default"]=_,u["default"].setQueryController({find:function(e,t,r){var n=u["default"].getRESTController();return n.request("GET","classes/"+e,t,r)}}),t.exports=r["default"]},{"./CoreManager":3,"./ParseError":13,"./ParseGeoPoint":15,"./ParseObject":18,"./ParsePromise":20,"./encode":36,"babel-runtime/helpers/class-call-check":52,"babel-runtime/helpers/create-class":53,"babel-runtime/helpers/interop-require-default":56}],22:[function(e,t,r){"use strict";var n=e("babel-runtime/helpers/create-class")["default"],a=e("babel-runtime/helpers/class-call-check")["default"],i=e("babel-runtime/helpers/interop-require-default")["default"];Object.defineProperty(r,"__esModule",{value:!0});var s=e("./ParseOp"),o=e("./ParseObject"),u=(i(o),e("./ParseQuery")),l=i(u),c=function(){function e(t,r){a(this,e),this.parent=t,this.key=r,this.targetClassName=null}return n(e,[{key:"_ensureParentAndKey",value:function(e,t){if(this.key=this.key||t,this.key!==t)throw new Error("Internal Error. Relation retrieved from two different keys.");if(this.parent){if(this.parent.className!==e.className)throw new Error("Internal Error. Relation retrieved from two different Objects.");if(this.parent.id){if(this.parent.id!==e.id)throw new Error("Internal Error. Relation retrieved from two different Objects.")}else e.id&&(this.parent=e)}else this.parent=e}},{key:"add",value:function(e){Array.isArray(e)||(e=[e]);var t=new s.RelationOp(e,[]),r=this.parent;if(!r)throw new Error("Cannot add to a Relation without a parent");return r.set(this.key,t),this.targetClassName=t._targetClassName,r}},{key:"remove",value:function(e){Array.isArray(e)||(e=[e]);var t=new s.RelationOp([],e);if(!this.parent)throw new Error("Cannot remove from a Relation without a parent");this.parent.set(this.key,t),this.targetClassName=t._targetClassName}},{key:"toJSON",value:function(){return{__type:"Relation",className:this.targetClassName}}},{key:"query",value:function t(){var t,e=this.parent;if(!e)throw new Error("Cannot construct a query for a Relation without a parent");return this.targetClassName?t=new l["default"](this.targetClassName):(t=new l["default"](e.className),t._extraOptions.redirectClassNameForKey=this.key),t._addCondition("$relatedTo","object",{__type:"Pointer",className:e.className,objectId:e.id}),t._addCondition("$relatedTo","key",this.key),t}}]),e}();r["default"]=c,t.exports=r["default"]},{"./ParseObject":18,"./ParseOp":19,"./ParseQuery":21,"babel-runtime/helpers/class-call-check":52,"babel-runtime/helpers/create-class":53,"babel-runtime/helpers/interop-require-default":56}],23:[function(e,t,r){"use strict";var n=e("babel-runtime/helpers/get")["default"],a=e("babel-runtime/helpers/inherits")["default"],i=e("babel-runtime/helpers/create-class")["default"],s=e("babel-runtime/helpers/class-call-check")["default"],o=e("babel-runtime/helpers/interop-require-default")["default"];Object.defineProperty(r,"__esModule",{value:!0});var u=e("./ParseACL"),l=o(u),c=e("./ParseError"),f=o(c),d=e("./ParseObject"),h=o(d),p=function(e){function t(e,r){s(this,t),n(Object.getPrototypeOf(t.prototype),"constructor",this).call(this,"_Role"),"string"==typeof e&&r instanceof l["default"]&&(this.setName(e),this.setACL(r))}return a(t,e),i(t,[{key:"getName",value:function(){var e=this.get("name");return null==e||"string"==typeof e?e:""}},{key:"setName",value:function(e,t){return this.set("name",e,t)}},{key:"getUsers",value:function(){return this.relation("users")}},{key:"getRoles",value:function(){return this.relation("roles")}},{key:"validate",value:function(e,r){var a=n(Object.getPrototypeOf(t.prototype),"validate",this).call(this,e,r);if(a)return a;if("name"in e&&e.name!==this.getName()){var i=e.name;if(this.id&&this.id!==e.objectId)return new f["default"](f["default"].OTHER_CAUSE,"A role's name can only be set before it has been saved.");if("string"!=typeof i)return new f["default"](f["default"].OTHER_CAUSE,"A role's name must be a String.");if(!/^[0-9a-zA-Z\-_ ]+$/.test(i))return new f["default"](f["default"].OTHER_CAUSE,"A role's name can be only contain alphanumeric characters, _, -, and spaces.")}return!1}}]),t}(h["default"]);r["default"]=p,h["default"].registerSubclass("_Role",p),t.exports=r["default"]},{"./ParseACL":11,"./ParseError":13,"./ParseObject":18,"babel-runtime/helpers/class-call-check":52,"babel-runtime/helpers/create-class":53,"babel-runtime/helpers/get":54,"babel-runtime/helpers/inherits":55,"babel-runtime/helpers/interop-require-default":56}],24:[function(e,t,r){"use strict";var n=e("babel-runtime/helpers/get")["default"],a=e("babel-runtime/helpers/inherits")["default"],i=e("babel-runtime/helpers/create-class")["default"],s=e("babel-runtime/helpers/class-call-check")["default"],o=e("babel-runtime/helpers/interop-require-default")["default"];Object.defineProperty(r,"__esModule",{value:!0});var u=e("./CoreManager"),l=o(u),c=e("./isRevocableSession"),f=o(c),d=e("./ParseObject"),h=o(d),p=e("./ParsePromise"),v=o(p),y=e("./ParseUser"),b=o(y),g=function(e){function t(e){if(s(this,t),n(Object.getPrototypeOf(t.prototype),"constructor",this).call(this,"_Session"),e&&"object"==typeof e&&!this.set(e||{}))throw new Error("Can't create an invalid Session")}return a(t,e),i(t,[{key:"getSessionToken",value:function(){var e=this.get("sessionToken");return"string"==typeof e?e:""}}],[{key:"readOnlyAttributes",value:function(){return["createdWith","expiresAt","installationId","restricted","sessionToken","user"]}},{key:"current",value:function(e){e=e||{};var t=l["default"].getSessionController(),r={};return e.hasOwnProperty("useMasterKey")&&(r.useMasterKey=e.useMasterKey),b["default"].currentAsync().then(function(e){if(!e)return v["default"].error("There is no current user.");e.getSessionToken();return r.sessionToken=e.getSessionToken(),t.getSession(r)})}},{key:"isCurrentSessionRevocable",value:function(){var e=b["default"].current();return!!e&&(0,f["default"])(e.getSessionToken()||"")}}]),t}(h["default"]);r["default"]=g,h["default"].registerSubclass("_Session",g),l["default"].setSessionController({getSession:function(e){var t=l["default"].getRESTController(),r=new g;return t.request("GET","sessions/me",{},e).then(function(e){return r._finishFetch(e),r._setExisted(!0),r})}}),t.exports=r["default"]},{"./CoreManager":3,"./ParseObject":18,"./ParsePromise":20,"./ParseUser":25,"./isRevocableSession":39,"babel-runtime/helpers/class-call-check":52,"babel-runtime/helpers/create-class":53,"babel-runtime/helpers/get":54,"babel-runtime/helpers/inherits":55,"babel-runtime/helpers/interop-require-default":56}],25:[function(e,t,r){"use strict";var n=e("babel-runtime/helpers/get")["default"],a=e("babel-runtime/helpers/inherits")["default"],i=e("babel-runtime/helpers/create-class")["default"],s=e("babel-runtime/helpers/class-call-check")["default"],o=e("babel-runtime/core-js/object/define-property")["default"],u=e("babel-runtime/helpers/interop-require-default")["default"];Object.defineProperty(r,"__esModule",{value:!0});var l=e("./CoreManager"),c=u(l),f=e("./isRevocableSession"),d=u(f),h=e("./ParseError"),p=u(h),v=e("./ParseObject"),y=u(v),b=e("./ParsePromise"),g=u(b),_=e("./ParseSession"),m=u(_),O=e("./Storage"),C=u(O),k="currentUser",w=!c["default"].get("IS_NODE"),S=!1,E=null,P={},j=function(e){function t(e){if(s(this,t),n(Object.getPrototypeOf(t.prototype),"constructor",this).call(this,"_User"),e&&"object"==typeof e&&!this.set(e||{}))throw new Error("Can't create an invalid Parse User")}return a(t,e),i(t,[{key:"_upgradeToRevocableSession",value:function(e){e=e||{};var t={};e.hasOwnProperty("useMasterKey")&&(t.useMasterKey=e.useMasterKey);var r=c["default"].getUserController();return r.upgradeToRevocableSession(this,t)._thenRunCallbacks(e)}},{key:"_linkWith",value:function(e,t){var r,n=this;if("string"==typeof e?(r=e,e=P[e]):r=e.getAuthType(),t&&t.hasOwnProperty("authData")){var a=this.get("authData")||{};if("object"!=typeof a)throw new Error("Invalid type: authData field should be an object");a[r]=t.authData;var i=c["default"].getUserController();return i.linkWith(this,a)._thenRunCallbacks(t,this)}var s=new g["default"];return e.authenticate({success:function(e,r){var a={};a.authData=r,t.success&&(a.success=t.success),t.error&&(a.error=t.error),n._linkWith(e,a).then(function(){s.resolve(n)},function(e){s.reject(e)})},error:function(e,r){t.error&&t.error(n,r),s.reject(r)}}),s}},{key:"_synchronizeAuthData",value:function(e){if(this.isCurrent()&&e){var t;"string"==typeof e?(t=e,e=P[t]):t=e.getAuthType();var r=this.get("authData");if(e&&r&&"object"==typeof r){var n=e.restoreAuthentication(r[t]);n||this._unlinkFrom(e)}}}},{key:"_synchronizeAllAuthData",value:function(){var e=this.get("authData");if("object"==typeof e)for(var t in e)this._synchronizeAuthData(t)}},{key:"_cleanupAuthData",value:function(){if(this.isCurrent()){var e=this.get("authData");if("object"==typeof e)for(var t in e)e[t]||delete e[t]}}},{key:"_unlinkFrom",value:function(e,t){var r,n=this;return"string"==typeof e?(r=e,e=P[e]):r=e.getAuthType(),this._linkWith(e,{authData:null}).then(function(){return n._synchronizeAuthData(e),g["default"].as(n)})._thenRunCallbacks(t)}},{key:"_isLinked",value:function(e){var t;t="string"==typeof e?e:e.getAuthType();var r=this.get("authData")||{};return"object"==typeof r&&!!r[t]}},{key:"_logOutWithAll",value:function(){var e=this.get("authData");if("object"==typeof e)for(var t in e)this._logOutWith(t)}},{key:"_logOutWith",value:function(e){this.isCurrent()&&("string"==typeof e&&(e=P[e]),e&&e.deauthenticate&&e.deauthenticate())}},{key:"_preserveFieldsOnFetch",value:function(){return{sessionToken:this.get("sessionToken")}}},{key:"isCurrent",value:function(){var e=t.current();return!!e&&e.id===this.id}},{key:"getUsername",value:function(){var e=this.get("username");return null==e||"string"==typeof e?e:""}},{key:"setUsername",value:function(e){var t=this.get("authData");t&&"object"==typeof t&&t.hasOwnProperty("anonymous")&&(t.anonymous=null),this.set("username",e)}},{key:"setPassword",value:function(e){this.set("password",e)}},{key:"getEmail",value:function(){var e=this.get("email");return null==e||"string"==typeof e?e:""}},{key:"setEmail",value:function(e){this.set("email",e)}},{key:"getSessionToken",value:function(){var e=this.get("sessionToken");return null==e||"string"==typeof e?e:""}},{key:"authenticated",value:function(){var e=t.current();return!!this.get("sessionToken")&&!!e&&e.id===this.id}},{key:"signUp",value:function(e,t){t=t||{};var r={};t.hasOwnProperty("useMasterKey")&&(r.useMasterKey=t.useMasterKey),t.hasOwnProperty("installationId")&&(r.installationId=t.installationId);var n=c["default"].getUserController();return n.signUp(this,e,r)._thenRunCallbacks(t,this)}},{key:"logIn",value:function(e){e=e||{};var t={};e.hasOwnProperty("useMasterKey")&&(t.useMasterKey=e.useMasterKey),e.hasOwnProperty("installationId")&&(t.installationId=e.installationId);var r=c["default"].getUserController();return r.logIn(this,t)._thenRunCallbacks(e,this)}},{key:"save",value:function(){for(var e=this,r=arguments.length,a=Array(r),i=0;i<r;i++)a[i]=arguments[i];return n(Object.getPrototypeOf(t.prototype),"save",this).apply(this,a).then(function(){return e.isCurrent()?c["default"].getUserController().updateUserOnDisk(e):e})}},{key:"destroy",value:function(){for(var e=this,r=arguments.length,a=Array(r),i=0;i<r;i++)a[i]=arguments[i];return n(Object.getPrototypeOf(t.prototype),"destroy",this).apply(this,a).then(function(){return e.isCurrent()?c["default"].getUserController().removeUserFromDisk():e})}},{key:"fetch",value:function(){for(var e=this,r=arguments.length,a=Array(r),i=0;i<r;i++)a[i]=arguments[i];return n(Object.getPrototypeOf(t.prototype),"fetch",this).apply(this,a).then(function(){return e.isCurrent()?c["default"].getUserController().updateUserOnDisk(e):e})}}],[{key:"readOnlyAttributes",value:function(){return["sessionToken"]}},{key:"extend",value:function(e,r){if(e)for(var n in e)"className"!==n&&o(t.prototype,n,{value:e[n],enumerable:!1,writable:!0,configurable:!0});if(r)for(var n in r)"className"!==n&&o(t,n,{value:r[n],enumerable:!1,writable:!0,configurable:!0});return t}},{key:"current",value:function(){if(!w)return null;var e=c["default"].getUserController();return e.currentUser()}},{key:"currentAsync",value:function(){if(!w)return g["default"].as(null);var e=c["default"].getUserController();return e.currentUserAsync()}},{key:"signUp",value:function(e,r,n,a){n=n||{},n.username=e,n.password=r;var i=new t(n);return i.signUp({},a)}},{key:"logIn",value:function(e,r,n){if("string"!=typeof e)return g["default"].error(new p["default"](p["default"].OTHER_CAUSE,"Username must be a string."));if("string"!=typeof r)return g["default"].error(new p["default"](p["default"].OTHER_CAUSE,"Password must be a string."));var a=new t;return a._finishFetch({username:e,password:r}),a.logIn(n)}},{key:"become",value:function(e,t){if(!w)throw new Error("It is not memory-safe to become a user in a server environment");t=t||{};var r={sessionToken:e};t.hasOwnProperty("useMasterKey")&&(r.useMasterKey=t.useMasterKey);var n=c["default"].getUserController();
return n.become(r)._thenRunCallbacks(t)}},{key:"logInWith",value:function(e,r){return t._logInWith(e,r)}},{key:"logOut",value:function(){if(!w)throw new Error("There is no current user user on a node.js server environment.");var e=c["default"].getUserController();return e.logOut()}},{key:"requestPasswordReset",value:function(e,t){t=t||{};var r={};t.hasOwnProperty("useMasterKey")&&(r.useMasterKey=t.useMasterKey);var n=c["default"].getUserController();return n.requestPasswordReset(e,r)._thenRunCallbacks(t)}},{key:"allowCustomUserClass",value:function(e){c["default"].set("PERFORM_USER_REWRITE",!e)}},{key:"enableRevocableSession",value:function(e){if(e=e||{},c["default"].set("FORCE_REVOCABLE_SESSION",!0),w){var r=t.current();if(r)return r._upgradeToRevocableSession(e)}return g["default"].as()._thenRunCallbacks(e)}},{key:"enableUnsafeCurrentUser",value:function(){w=!0}},{key:"disableUnsafeCurrentUser",value:function(){w=!1}},{key:"_registerAuthenticationProvider",value:function(e){P[e.getAuthType()]=e,t.currentAsync().then(function(t){t&&t._synchronizeAuthData(e.getAuthType())})}},{key:"_logInWith",value:function(e,r){var n=new t;return n._linkWith(e,r)}},{key:"_clearCache",value:function(){E=null,S=!1}},{key:"_setCurrentUserCache",value:function(e){E=e}}]),t}(y["default"]);r["default"]=j,y["default"].registerSubclass("_User",j);var A={updateUserOnDisk:function(e){var t=C["default"].generatePath(k),r=e.toJSON();return r.className="_User",C["default"].setItemAsync(t,JSON.stringify(r)).then(function(){return e})},removeUserFromDisk:function(){var e=C["default"].generatePath(k);return S=!0,E=null,C["default"].removeItemAsync(e)},setCurrentUser:function(e){return E=e,e._cleanupAuthData(),e._synchronizeAllAuthData(),A.updateUserOnDisk(e)},currentUser:function(){if(E)return E;if(S)return null;if(C["default"].async())throw new Error("Cannot call currentUser() when using a platform with an async storage system. Call currentUserAsync() instead.");var e=C["default"].generatePath(k),t=C["default"].getItem(e);if(S=!0,!t)return E=null,null;t=JSON.parse(t),t.className||(t.className="_User"),t._id&&(t.objectId!==t._id&&(t.objectId=t._id),delete t._id),t._sessionToken&&(t.sessionToken=t._sessionToken,delete t._sessionToken);var r=y["default"].fromJSON(t);return E=r,r._synchronizeAllAuthData(),r},currentUserAsync:function(){if(E)return g["default"].as(E);if(S)return g["default"].as(null);var e=C["default"].generatePath(k);return C["default"].getItemAsync(e).then(function(e){if(S=!0,!e)return E=null,g["default"].as(null);e=JSON.parse(e),e.className||(e.className="_User"),e._id&&(e.objectId!==e._id&&(e.objectId=e._id),delete e._id),e._sessionToken&&(e.sessionToken=e._sessionToken,delete e._sessionToken);var t=y["default"].fromJSON(e);return E=t,t._synchronizeAllAuthData(),g["default"].as(t)})},signUp:function(e,t,r){var n=t&&t.username||e.get("username"),a=t&&t.password||e.get("password");return n&&n.length?a&&a.length?e.save(t,r).then(function(){return e._finishFetch({password:void 0}),w?A.setCurrentUser(e):e}):g["default"].error(new p["default"](p["default"].OTHER_CAUSE,"Cannot sign up user with an empty password.")):g["default"].error(new p["default"](p["default"].OTHER_CAUSE,"Cannot sign up user with an empty name."))},logIn:function(e,t){var r=c["default"].getRESTController(),n=c["default"].getObjectStateController(),a={username:e.get("username"),password:e.get("password")};return r.request("GET","login",a,t).then(function(t,r){return e._migrateId(t.objectId),e._setExisted(!0),n.setPendingOp(e._getStateIdentifier(),"username",void 0),n.setPendingOp(e._getStateIdentifier(),"password",void 0),t.password=void 0,e._finishFetch(t),w?A.setCurrentUser(e):g["default"].as(e)})},become:function(e){var t=new j,r=c["default"].getRESTController();return r.request("GET","users/me",{},e).then(function(e,r){return t._finishFetch(e),t._setExisted(!0),A.setCurrentUser(t)})},logOut:function(){return A.currentUserAsync().then(function(e){var t=C["default"].generatePath(k),r=C["default"].removeItemAsync(t),n=c["default"].getRESTController();if(null!==e){var a=e.getSessionToken();a&&(0,d["default"])(a)&&(r=r.then(function(){return n.request("POST","logout",{},{sessionToken:a})})),e._logOutWithAll(),e._finishFetch({sessionToken:void 0})}return S=!0,E=null,r})},requestPasswordReset:function(e,t){var r=c["default"].getRESTController();return r.request("POST","requestPasswordReset",{email:e},t)},upgradeToRevocableSession:function(e,t){var r=e.getSessionToken();if(!r)return g["default"].error(new p["default"](p["default"].SESSION_MISSING,"Cannot upgrade a user with no session token"));t.sessionToken=r;var n=c["default"].getRESTController();return n.request("POST","upgradeToRevocableSession",{},t).then(function(t){var r=new m["default"];return r._finishFetch(t),e._finishFetch({sessionToken:r.getSessionToken()}),e.isCurrent()?A.setCurrentUser(e):g["default"].as(e)})},linkWith:function(e,t){return e.save({authData:t}).then(function(){return w?A.setCurrentUser(e):e})}};c["default"].setUserController(A),t.exports=r["default"]},{"./CoreManager":3,"./ParseError":13,"./ParseObject":18,"./ParsePromise":20,"./ParseSession":24,"./Storage":29,"./isRevocableSession":39,"babel-runtime/core-js/object/define-property":46,"babel-runtime/helpers/class-call-check":52,"babel-runtime/helpers/create-class":53,"babel-runtime/helpers/get":54,"babel-runtime/helpers/inherits":55,"babel-runtime/helpers/interop-require-default":56}],26:[function(e,t,r){"use strict";function n(e,t){if(t=t||{},e.where&&e.where instanceof u["default"]&&(e.where=e.where.toJSON().where),e.push_time&&"object"==typeof e.push_time&&(e.push_time=e.push_time.toJSON()),e.expiration_time&&"object"==typeof e.expiration_time&&(e.expiration_time=e.expiration_time.toJSON()),e.expiration_time&&e.expiration_interval)throw new Error("expiration_time and expiration_interval cannot both be set.");return s["default"].getPushController().send(e,{useMasterKey:t.useMasterKey})._thenRunCallbacks(t)}var a=e("babel-runtime/helpers/interop-require-default")["default"];Object.defineProperty(r,"__esModule",{value:!0}),r.send=n;var i=e("./CoreManager"),s=a(i),o=e("./ParseQuery"),u=a(o);s["default"].setPushController({send:function(e,t){var r=s["default"].getRESTController(),n=r.request("POST","push",e,{useMasterKey:!!t.useMasterKey});return n._thenRunCallbacks(t)}})},{"./CoreManager":3,"./ParseQuery":21,"babel-runtime/helpers/interop-require-default":56}],27:[function(e,t,r){(function(n){"use strict";function a(e,t,r){var n=new f["default"],a=new XDomainRequest;return a.onload=function(){var e;try{e=JSON.parse(a.responseText)}catch(t){n.reject(t)}e&&n.resolve(e)},a.onerror=a.ontimeout=function(){var e={responseText:JSON.stringify({code:l["default"].X_DOMAIN_REQUEST,error:"IE's XDomainRequest does not supply error info."})};n.reject(e)},a.onprogress=function(){},a.open(e,t),a.send(r),n}var i=e("babel-runtime/helpers/interop-require-default")["default"];Object.defineProperty(r,"__esModule",{value:!0});var s=e("./CoreManager"),o=i(s),u=e("./ParseError"),l=i(u),c=e("./ParsePromise"),f=i(c),d=e("./Storage"),h=(i(d),null);"undefined"!=typeof XMLHttpRequest&&(h=XMLHttpRequest);var p=!1;"undefined"==typeof XDomainRequest||"withCredentials"in new XMLHttpRequest||(p=!0);var v={ajax:function(e,t,r,i){if(p)return a(e,t,r,i);var s=new f["default"],u=0,l=function c(){if(null==h)throw new Error("Cannot make a request: No definition of XMLHttpRequest was found.");var a=!1,l=new h;l.onreadystatechange=function(){if(4===l.readyState&&!a)if(a=!0,l.status>=200&&l.status<300){var e;try{e=JSON.parse(l.responseText)}catch(t){s.reject(t.toString())}e&&s.resolve(e,l.status,l)}else if(l.status>=500||0===l.status)if(++u<o["default"].get("REQUEST_ATTEMPT_LIMIT")){var r=Math.round(125*Math.random()*Math.pow(2,u));setTimeout(c,r)}else 0===l.status?s.reject("Unable to connect to the Parse API"):s.reject(l);else s.reject(l)},i=i||{},"string"!=typeof i["Content-Type"]&&(i["Content-Type"]="text/plain"),o["default"].get("IS_NODE")&&(i["User-Agent"]="Parse/"+o["default"].get("VERSION")+" (NodeJS "+n.versions.node+")"),l.open(e,t,!0);for(var f in i)l.setRequestHeader(f,i[f]);l.send(r)};return l(),s},request:function(e,t,r,n){n=n||{};var a=o["default"].get("SERVER_URL");"/"!==a[a.length-1]&&(a+="/"),a+=t;var i={};if(r&&"object"==typeof r)for(var s in r)i[s]=r[s];"POST"!==e&&(i._method=e,e="POST"),i._ApplicationId=o["default"].get("APPLICATION_ID");var u=o["default"].get("JAVASCRIPT_KEY");u&&(i._JavaScriptKey=u),i._ClientVersion=o["default"].get("VERSION");var c=n.useMasterKey;if("undefined"==typeof c&&(c=o["default"].get("USE_MASTER_KEY")),c){if(!o["default"].get("MASTER_KEY"))throw new Error("Cannot use the Master Key, it has not been provided.");delete i._JavaScriptKey,i._MasterKey=o["default"].get("MASTER_KEY")}o["default"].get("FORCE_REVOCABLE_SESSION")&&(i._RevocableSession="1");var d,h=n.installationId;if(h&&"string"==typeof h)d=f["default"].as(h);else{var p=o["default"].getInstallationController();d=p.currentInstallationId()}return d.then(function(e){i._InstallationId=e;var t=o["default"].getUserController();return n&&"string"==typeof n.sessionToken?f["default"].as(n.sessionToken):t?t.currentUserAsync().then(function(e){return e?f["default"].as(e.getSessionToken()):f["default"].as(null)}):f["default"].as(null)}).then(function(t){t&&(i._SessionToken=t);var r=JSON.stringify(i);return v.ajax(e,a,r)}).then(null,function(e){var t;if(e&&e.responseText)try{var r=JSON.parse(e.responseText);t=new l["default"](r.code,r.error)}catch(n){t=new l["default"](l["default"].INVALID_JSON,"Received an error with invalid JSON from Parse: "+e.responseText)}else t=new l["default"](l["default"].CONNECTION_FAILED,"XMLHttpRequest failed: "+JSON.stringify(e));return f["default"].error(t)})},_setXHR:function(e){h=e}};t.exports=v}).call(this,e("_process"))},{"./CoreManager":3,"./ParseError":13,"./ParsePromise":20,"./Storage":29,_process:58,"babel-runtime/helpers/interop-require-default":56}],28:[function(e,t,r){"use strict";function n(e){var t=k[e.className];return t?t[e.id]||null:null}function a(e,t){var r=n(e);return r?r:(k[e.className]||(k[e.className]={}),t||(t=C.defaultState()),r=k[e.className][e.id]=t)}function i(e){var t=n(e);return null===t?null:(delete k[e.className][e.id],t)}function s(e){var t=n(e);return t?t.serverData:{}}function o(e,t){var r=a(e).serverData;C.setServerData(r,t)}function u(e){var t=n(e);return t?t.pendingOps:[{}]}function l(e,t,r){var n=a(e).pendingOps;C.setPendingOp(n,t,r)}function c(e){var t=a(e).pendingOps;C.pushPendingState(t)}function f(e){var t=a(e).pendingOps;return C.popPendingState(t)}function d(e){var t=u(e);C.mergeFirstPendingState(t)}function h(e){var t=n(e);return t?t.objectCache:{}}function p(e,t){var r=s(e),n=u(e);return C.estimateAttribute(r,n,e.className,e.id,t)}function v(e){var t=s(e),r=u(e);return C.estimateAttributes(t,r,e.className,e.id)}function y(e,t){var r=a(e);C.commitServerChanges(r.serverData,r.objectCache,t)}function b(e,t){var r=a(e);return r.tasks.enqueue(t)}function g(){k={}}function _(e,t){t.id=e.id}var m=e("babel-runtime/helpers/interop-require-wildcard")["default"];Object.defineProperty(r,"__esModule",{value:!0}),r.getState=n,r.initializeState=a,r.removeState=i,r.getServerData=s,r.setServerData=o,r.getPendingOps=u,r.setPendingOp=l,r.pushPendingState=c,r.popPendingState=f,r.mergeFirstPendingState=d,r.getObjectCache=h,r.estimateAttribute=p,r.estimateAttributes=v,r.commitServerChanges=y,r.enqueueTask=b,r.clearAllState=g,r.duplicateState=_;var O=e("./ObjectStateMutations"),C=m(O),k={}},{"./ObjectStateMutations":9,"babel-runtime/helpers/interop-require-wildcard":57}],29:[function(e,t,r){"use strict";var n=e("babel-runtime/helpers/interop-require-default")["default"],a=e("./CoreManager"),i=n(a),s=e("./ParsePromise"),o=n(s);t.exports={async:function(){var e=i["default"].getStorageController();return!!e.async},getItem:function(e){var t=i["default"].getStorageController();if(1===t.async)throw new Error("Synchronous storage is not supported by the current storage controller");return t.getItem(e)},getItemAsync:function(e){var t=i["default"].getStorageController();return 1===t.async?t.getItemAsync(e):o["default"].as(t.getItem(e))},setItem:function(e,t){var r=i["default"].getStorageController();if(1===r.async)throw new Error("Synchronous storage is not supported by the current storage controller");return r.setItem(e,t)},setItemAsync:function(e,t){var r=i["default"].getStorageController();return 1===r.async?r.setItemAsync(e,t):o["default"].as(r.setItem(e,t))},removeItem:function(e){var t=i["default"].getStorageController();if(1===t.async)throw new Error("Synchronous storage is not supported by the current storage controller");return t.removeItem(e)},removeItemAsync:function(e){var t=i["default"].getStorageController();return 1===t.async?t.removeItemAsync(e):o["default"].as(t.removeItem(e))},generatePath:function(e){if(!i["default"].get("APPLICATION_ID"))throw new Error("You need to call Parse.initialize before using Parse.");if("string"!=typeof e)throw new Error("Tried to get a Storage path that was not a String.");return"/"===e[0]&&(e=e.substr(1)),"Parse/"+i["default"].get("APPLICATION_ID")+"/"+e},_clear:function(){var e=i["default"].getStorageController();e.hasOwnProperty("clear")&&e.clear()}},i["default"].setStorageController(e("./StorageController.browser"))},{"./CoreManager":3,"./ParsePromise":20,"./StorageController.browser":30,"babel-runtime/helpers/interop-require-default":56}],30:[function(e,t,r){"use strict";var n=e("babel-runtime/helpers/interop-require-default")["default"],a=e("./ParsePromise");n(a);t.exports={async:0,getItem:function(e){return localStorage.getItem(e)},setItem:function(e,t){try{localStorage.setItem(e,t)}catch(r){}},removeItem:function(e){localStorage.removeItem(e)},clear:function(){localStorage.clear()}}},{"./ParsePromise":20,"babel-runtime/helpers/interop-require-default":56}],31:[function(e,t,r){"use strict";var n=e("babel-runtime/helpers/create-class")["default"],a=e("babel-runtime/helpers/class-call-check")["default"],i=e("babel-runtime/helpers/interop-require-default")["default"],s=e("./ParsePromise"),o=i(s);t.exports=function(){function e(){a(this,e),this.queue=[]}return n(e,[{key:"enqueue",value:function(e){var t=this,r=new o["default"];return this.queue.push({task:e,_completion:r}),1===this.queue.length&&e().then(function(){t._dequeue(),r.resolve()},function(e){t._dequeue(),r.reject(e)}),r}},{key:"_dequeue",value:function(){var e=this;if(this.queue.shift(),this.queue.length){var t=this.queue[0];t.task().then(function(){e._dequeue(),t._completion.resolve()},function(r){e._dequeue(),t._completion.reject(r)})}}}]),e}()},{"./ParsePromise":20,"babel-runtime/helpers/class-call-check":52,"babel-runtime/helpers/create-class":53,"babel-runtime/helpers/interop-require-default":56}],32:[function(e,t,r){"use strict";function n(e){var t=P.get(e);return t||null}function a(e,t){var r=n(e);return r?r:(t||(t={serverData:{},pendingOps:[{}],objectCache:{},tasks:new E["default"],existed:!1}),r=t,P.set(e,r),r)}function i(e){var t=n(e);return null===t?null:(P["delete"](e),t)}function s(e){var t=n(e);return t?t.serverData:{}}function o(e,t){var r=a(e).serverData;w.setServerData(r,t)}function u(e){var t=n(e);return t?t.pendingOps:[{}]}function l(e,t,r){var n=a(e).pendingOps;w.setPendingOp(n,t,r)}function c(e){var t=a(e).pendingOps;w.pushPendingState(t)}function f(e){var t=a(e).pendingOps;return w.popPendingState(t)}function d(e){var t=u(e);w.mergeFirstPendingState(t)}function h(e){var t=n(e);return t?t.objectCache:{}}function p(e,t){var r=s(e),n=u(e);return w.estimateAttribute(r,n,e.className,e.id,t)}function v(e){var t=s(e),r=u(e);return w.estimateAttributes(t,r,e.className,e.id)}function y(e,t){var r=a(e);w.commitServerChanges(r.serverData,r.objectCache,t)}function b(e,t){var r=a(e);return r.tasks.enqueue(t)}function g(e,t){var r=a(e),n=a(t);for(var i in r.serverData)n.serverData[i]=r.serverData[i];for(var s=0;s<r.pendingOps.length;s++)for(var i in r.pendingOps[s])n.pendingOps[s][i]=r.pendingOps[s][i];for(var i in r.objectCache)n.objectCache[i]=r.objectCache[i];n.existed=r.existed}function _(){P=new m}var m=e("babel-runtime/core-js/weak-map")["default"],O=e("babel-runtime/helpers/interop-require-wildcard")["default"],C=e("babel-runtime/helpers/interop-require-default")["default"];Object.defineProperty(r,"__esModule",{value:!0}),r.getState=n,r.initializeState=a,r.removeState=i,r.getServerData=s,r.setServerData=o,r.getPendingOps=u,r.setPendingOp=l,r.pushPendingState=c,r.popPendingState=f,r.mergeFirstPendingState=d,r.getObjectCache=h,r.estimateAttribute=p,r.estimateAttributes=v,r.commitServerChanges=y,r.enqueueTask=b,r.duplicateState=g,r.clearAllState=_;var k=e("./ObjectStateMutations"),w=O(k),S=e("./TaskQueue"),E=C(S),P=new m},{"./ObjectStateMutations":9,"./TaskQueue":31,"babel-runtime/core-js/weak-map":51,"babel-runtime/helpers/interop-require-default":56,"babel-runtime/helpers/interop-require-wildcard":57}],33:[function(e,t,r){"use strict";function n(e,t){if(e.indexOf(t)>-1)return!0;for(var r=0;r<e.length;r++)if(e[r]instanceof s["default"]&&e[r].className===t.className&&e[r]._getId()===t._getId())return!0;return!1}var a=e("babel-runtime/helpers/interop-require-default")["default"];Object.defineProperty(r,"__esModule",{value:!0}),r["default"]=n;var i=e("./ParseObject"),s=a(i);t.exports=r["default"]},{"./ParseObject":18,"babel-runtime/helpers/interop-require-default":56}],34:[function(e,t,r){"use strict";function n(e){if(!(e instanceof l["default"]))return!0;var t=e.attributes;for(var r in t){var n=t[r];if(!a(n))return!1}return!0}function a(e){if("object"!=typeof e)return!0;if(e instanceof f["default"])return!0;if(e instanceof l["default"])return!!e.id;if(e instanceof o["default"])return!!e.url();if(Array.isArray(e)){for(var t=0;t<e.length;t++)if(!a(e[t]))return!1;return!0}for(var r in e)if(!a(e[r]))return!1;return!0}var i=e("babel-runtime/helpers/interop-require-default")["default"];Object.defineProperty(r,"__esModule",{value:!0}),r["default"]=n;var s=e("./ParseFile"),o=i(s),u=e("./ParseObject"),l=i(u),c=e("./ParseRelation"),f=i(c);t.exports=r["default"]},{"./ParseFile":14,"./ParseObject":18,"./ParseRelation":22,"babel-runtime/helpers/interop-require-default":56}],35:[function(e,t,r){"use strict";function n(e){if(null===e||"object"!=typeof e)return e;if(Array.isArray(e)){var t=[];return e.forEach(function(e,r){t[r]=n(e)}),t}if("string"==typeof e.__op)return(0,d.opFromJSON)(e);if("Pointer"===e.__type&&e.className)return f["default"].fromJSON(e);if("Object"===e.__type&&e.className)return f["default"].fromJSON(e);if("Relation"===e.__type){var r=new p["default"](null,null);return r.targetClassName=e.className,r}if("Date"===e.__type)return new Date(e.iso);if("File"===e.__type)return o["default"].fromJSON(e);if("GeoPoint"===e.__type)return new l["default"]({latitude:e.latitude,longitude:e.longitude});var a={};for(var i in e)a[i]=n(e[i]);return a}var a=e("babel-runtime/helpers/interop-require-default")["default"];Object.defineProperty(r,"__esModule",{value:!0}),r["default"]=n;var i=e("./ParseACL"),s=(a(i),e("./ParseFile")),o=a(s),u=e("./ParseGeoPoint"),l=a(u),c=e("./ParseObject"),f=a(c),d=e("./ParseOp"),h=e("./ParseRelation"),p=a(h);t.exports=r["default"]},{"./ParseACL":11,"./ParseFile":14,"./ParseGeoPoint":15,"./ParseObject":18,"./ParseOp":19,"./ParseRelation":22,"babel-runtime/helpers/interop-require-default":56}],36:[function(e,t,r){"use strict";function n(e,t,r,i){if(e instanceof h["default"]){if(t)throw new Error("Parse Objects not allowed here");var s=e.id?e.className+":"+e.id:e;return r||!i||i.indexOf(s)>-1||e.dirty()||a(e._getServerData()).length<1?e.toPointer():(i=i.concat(s),e._toFullJSON(i))}if(e instanceof p.Op||e instanceof o["default"]||e instanceof f["default"]||e instanceof y["default"])return e.toJSON();if(e instanceof l["default"]){if(!e.url())throw new Error("Tried to encode an unsaved file.");return e.toJSON()}if("[object Date]"===b.call(e)){if(isNaN(e))throw new Error("Tried to encode an invalid date.");return{__type:"Date",iso:e.toJSON()}}if("[object RegExp]"===b.call(e)&&"string"==typeof e.source)return e.source;if(Array.isArray(e))return e.map(function(e){return n(e,t,r,i)});if(e&&"object"==typeof e){var u={};for(var c in e)u[c]=n(e[c],t,r,i);return u}return e}var a=e("babel-runtime/core-js/object/keys")["default"],i=e("babel-runtime/helpers/interop-require-default")["default"];Object.defineProperty(r,"__esModule",{value:!0});var s=e("./ParseACL"),o=i(s),u=e("./ParseFile"),l=i(u),c=e("./ParseGeoPoint"),f=i(c),d=e("./ParseObject"),h=i(d),p=e("./ParseOp"),v=e("./ParseRelation"),y=i(v),b=Object.prototype.toString;r["default"]=function(e,t,r,a){return n(e,!!t,!!r,a||[])},t.exports=r["default"]},{"./ParseACL":11,"./ParseFile":14,"./ParseGeoPoint":15,"./ParseObject":18,"./ParseOp":19,"./ParseRelation":22,"babel-runtime/core-js/object/keys":49,"babel-runtime/helpers/interop-require-default":56}],37:[function(e,t,r){"use strict";function n(e,t){if(typeof e!=typeof t)return!1;if(!e||"object"!=typeof e)return e===t;if(Array.isArray(e)||Array.isArray(t)){if(!Array.isArray(e)||!Array.isArray(t))return!1;if(e.length!==t.length)return!1;for(var r=e.length;r--;)if(!n(e[r],t[r]))return!1;return!0}if(e instanceof o["default"]||e instanceof l["default"]||e instanceof f["default"]||e instanceof h["default"])return e.equals(t);if(a(e).length!==a(t).length)return!1;for(var i in e)if(!n(e[i],t[i]))return!1;return!0}var a=e("babel-runtime/core-js/object/keys")["default"],i=e("babel-runtime/helpers/interop-require-default")["default"];Object.defineProperty(r,"__esModule",{value:!0}),r["default"]=n;var s=e("./ParseACL"),o=i(s),u=e("./ParseFile"),l=i(u),c=e("./ParseGeoPoint"),f=i(c),d=e("./ParseObject"),h=i(d);t.exports=r["default"]},{"./ParseACL":11,"./ParseFile":14,"./ParseGeoPoint":15,"./ParseObject":18,"babel-runtime/core-js/object/keys":49,"babel-runtime/helpers/interop-require-default":56}],38:[function(e,t,r){"use strict";function n(e){return e.replace(/[&<>\/'"]/g,function(e){return{"&":"&amp;","<":"&lt;",">":"&gt;","/":"&#x2F;","'":"&#x27;",'"':"&quot;"}[e]})}Object.defineProperty(r,"__esModule",{value:!0}),r["default"]=n,t.exports=r["default"]},{}],39:[function(e,t,r){"use strict";function n(e){return e.indexOf("r:")>-1}Object.defineProperty(r,"__esModule",{value:!0}),r["default"]=n,t.exports=r["default"]},{}],40:[function(e,t,r){"use strict";function n(e){var t=new RegExp("^([0-9]{1,4})-([0-9]{1,2})-([0-9]{1,2})T([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})(.([0-9]+))?Z$"),r=t.exec(e);if(!r)return null;var n=r[1]||0,a=(r[2]||1)-1,i=r[3]||0,s=r[4]||0,o=r[5]||0,u=r[6]||0,l=r[8]||0;return new Date(Date.UTC(n,a,i,s,o,u,l))}Object.defineProperty(r,"__esModule",{value:!0}),r["default"]=n,t.exports=r["default"]},{}],41:[function(e,t,r){"use strict";function n(e){var t=[];return e.forEach(function(e){e instanceof u["default"]?(0,s["default"])(t,e)||t.push(e):t.indexOf(e)<0&&t.push(e)}),t}var a=e("babel-runtime/helpers/interop-require-default")["default"];Object.defineProperty(r,"__esModule",{value:!0}),r["default"]=n;var i=e("./arrayContainsObject"),s=a(i),o=e("./ParseObject"),u=a(o);t.exports=r["default"]},{"./ParseObject":18,"./arrayContainsObject":33,"babel-runtime/helpers/interop-require-default":56}],42:[function(e,t,r){"use strict";function n(e,t){var r={objects:{},files:[]},n=e.className+":"+e._getId();r.objects[n]=!e.dirty()||e;var i=e.attributes;for(var s in i)"object"==typeof i[s]&&a(i[s],r,!1,!!t);var o=[];for(var u in r.objects)u!==n&&r.objects[u]!==!0&&o.push(r.objects[u]);return o.concat(r.files)}function a(e,t,r,n){if(e instanceof l["default"]){if(!e.id&&r)throw new Error("Cannot create a pointer to an unsaved Object.");var i=e.className+":"+e._getId();if(!t.objects[i]){t.objects[i]=!e.dirty()||e;var s=e.attributes;for(var u in s)"object"==typeof s[u]&&a(s[u],t,!n,n)}}else{if(e instanceof o["default"])return void(!e.url()&&t.files.indexOf(e)<0&&t.files.push(e));if(!(e instanceof f["default"])){Array.isArray(e)&&e.forEach(function(e){"object"==typeof e&&a(e,t,r,n)});for(var c in e)"object"==typeof e[c]&&a(e[c],t,r,n)}}}var i=e("babel-runtime/helpers/interop-require-default")["default"];Object.defineProperty(r,"__esModule",{value:!0}),r["default"]=n;var s=e("./ParseFile"),o=i(s),u=e("./ParseObject"),l=i(u),c=e("./ParseRelation"),f=i(c);t.exports=r["default"]},{"./ParseFile":14,"./ParseObject":18,"./ParseRelation":22,"babel-runtime/helpers/interop-require-default":56}],43:[function(e,t,r){t.exports={"default":e("core-js/library/fn/get-iterator"),__esModule:!0}},{"core-js/library/fn/get-iterator":59}],44:[function(e,t,r){t.exports={"default":e("core-js/library/fn/map"),__esModule:!0}},{"core-js/library/fn/map":60}],45:[function(e,t,r){t.exports={"default":e("core-js/library/fn/object/create"),__esModule:!0}},{"core-js/library/fn/object/create":61}],46:[function(e,t,r){t.exports={"default":e("core-js/library/fn/object/define-property"),__esModule:!0}},{"core-js/library/fn/object/define-property":62}],47:[function(e,t,r){t.exports={"default":e("core-js/library/fn/object/freeze"),__esModule:!0}},{"core-js/library/fn/object/freeze":63}],48:[function(e,t,r){t.exports={"default":e("core-js/library/fn/object/get-own-property-descriptor"),__esModule:!0}},{"core-js/library/fn/object/get-own-property-descriptor":64}],49:[function(e,t,r){t.exports={"default":e("core-js/library/fn/object/keys"),__esModule:!0}},{"core-js/library/fn/object/keys":65}],50:[function(e,t,r){t.exports={"default":e("core-js/library/fn/object/set-prototype-of"),__esModule:!0}},{"core-js/library/fn/object/set-prototype-of":66}],51:[function(e,t,r){t.exports={"default":e("core-js/library/fn/weak-map"),__esModule:!0}},{"core-js/library/fn/weak-map":67}],52:[function(e,t,r){"use strict";r["default"]=function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")},r.__esModule=!0},{}],53:[function(e,t,r){"use strict";var n=e("babel-runtime/core-js/object/define-property")["default"];r["default"]=function(){function e(e,t){for(var r=0;r<t.length;r++){var a=t[r];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),n(e,a.key,a)}}return function(t,r,n){return r&&e(t.prototype,r),n&&e(t,n),t}}(),r.__esModule=!0},{"babel-runtime/core-js/object/define-property":46}],54:[function(e,t,r){"use strict";var n=e("babel-runtime/core-js/object/get-own-property-descriptor")["default"];r["default"]=function(e,t,r){for(var a=!0;a;){var i=e,s=t,o=r;a=!1,null===i&&(i=Function.prototype);var u=n(i,s);if(void 0!==u){if("value"in u)return u.value;var l=u.get;if(void 0===l)return;return l.call(o)}var c=Object.getPrototypeOf(i);if(null===c)return;e=c,t=s,r=o,a=!0,u=c=void 0}},r.__esModule=!0},{"babel-runtime/core-js/object/get-own-property-descriptor":48}],55:[function(e,t,r){"use strict";var n=e("babel-runtime/core-js/object/create")["default"],a=e("babel-runtime/core-js/object/set-prototype-of")["default"];r["default"]=function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=n(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(a?a(e,t):e.__proto__=t)},r.__esModule=!0},{"babel-runtime/core-js/object/create":45,"babel-runtime/core-js/object/set-prototype-of":50}],56:[function(e,t,r){"use strict";r["default"]=function(e){return e&&e.__esModule?e:{"default":e}},r.__esModule=!0},{}],57:[function(e,t,r){"use strict";r["default"]=function(e){if(e&&e.__esModule)return e;var t={};if(null!=e)for(var r in e)Object.prototype.hasOwnProperty.call(e,r)&&(t[r]=e[r]);return t["default"]=e,t},r.__esModule=!0},{}],58:[function(e,t,r){},{}],59:[function(e,t,r){e("../modules/web.dom.iterable"),e("../modules/es6.string.iterator"),t.exports=e("../modules/core.get-iterator")},{"../modules/core.get-iterator":117,"../modules/es6.string.iterator":125,"../modules/web.dom.iterable":128}],60:[function(e,t,r){e("../modules/es6.object.to-string"),e("../modules/es6.string.iterator"),e("../modules/web.dom.iterable"),e("../modules/es6.map"),e("../modules/es7.map.to-json"),t.exports=e("../modules/$.core").Map},{"../modules/$.core":79,"../modules/es6.map":119,"../modules/es6.object.to-string":124,"../modules/es6.string.iterator":125,"../modules/es7.map.to-json":127,"../modules/web.dom.iterable":128}],61:[function(e,t,r){var n=e("../../modules/$");t.exports=function(e,t){return n.create(e,t)}},{"../../modules/$":98}],62:[function(e,t,r){var n=e("../../modules/$");t.exports=function(e,t,r){return n.setDesc(e,t,r)}},{"../../modules/$":98}],63:[function(e,t,r){e("../../modules/es6.object.freeze"),t.exports=e("../../modules/$.core").Object.freeze},{"../../modules/$.core":79,"../../modules/es6.object.freeze":120}],64:[function(e,t,r){var n=e("../../modules/$");e("../../modules/es6.object.get-own-property-descriptor"),t.exports=function(e,t){return n.getDesc(e,t)}},{"../../modules/$":98,"../../modules/es6.object.get-own-property-descriptor":121}],65:[function(e,t,r){e("../../modules/es6.object.keys"),t.exports=e("../../modules/$.core").Object.keys},{"../../modules/$.core":79,"../../modules/es6.object.keys":122}],66:[function(e,t,r){e("../../modules/es6.object.set-prototype-of"),t.exports=e("../../modules/$.core").Object.setPrototypeOf},{"../../modules/$.core":79,"../../modules/es6.object.set-prototype-of":123}],67:[function(e,t,r){e("../modules/es6.object.to-string"),e("../modules/web.dom.iterable"),e("../modules/es6.weak-map"),t.exports=e("../modules/$.core").WeakMap},{"../modules/$.core":79,"../modules/es6.object.to-string":124,"../modules/es6.weak-map":126,"../modules/web.dom.iterable":128}],68:[function(e,t,r){t.exports=function(e){if("function"!=typeof e)throw TypeError(e+" is not a function!");return e}},{}],69:[function(e,t,r){t.exports=function(){}},{}],70:[function(e,t,r){var n=e("./$.is-object");t.exports=function(e){if(!n(e))throw TypeError(e+" is not an object!");return e}},{"./$.is-object":92}],71:[function(e,t,r){var n=e("./$.ctx"),a=e("./$.iobject"),i=e("./$.to-object"),s=e("./$.to-length"),o=e("./$.array-species-create");t.exports=function(e){var t=1==e,r=2==e,u=3==e,l=4==e,c=6==e,f=5==e||c;return function(d,h,p){for(var v,y,b=i(d),g=a(b),_=n(h,p,3),m=s(g.length),O=0,C=t?o(d,m):r?o(d,0):void 0;m>O;O++)if((f||O in g)&&(v=g[O],y=_(v,O,b),e))if(t)C[O]=y;else if(y)switch(e){case 3:return!0;case 5:return v;case 6:return O;case 2:C.push(v)}else if(l)return!1;return c?-1:u||l?l:C}}},{"./$.array-species-create":72,"./$.ctx":80,"./$.iobject":89,"./$.to-length":112,"./$.to-object":113}],72:[function(e,t,r){var n=e("./$.is-object"),a=e("./$.is-array"),i=e("./$.wks")("species");t.exports=function(e,t){var r;return a(e)&&(r=e.constructor,"function"!=typeof r||r!==Array&&!a(r.prototype)||(r=void 0),n(r)&&(r=r[i],null===r&&(r=void 0))),new(void 0===r?Array:r)(t)}},{"./$.is-array":91,"./$.is-object":92,"./$.wks":115}],73:[function(e,t,r){var n=e("./$.cof"),a=e("./$.wks")("toStringTag"),i="Arguments"==n(function(){return arguments}());t.exports=function(e){var t,r,s;return void 0===e?"Undefined":null===e?"Null":"string"==typeof(r=(t=Object(e))[a])?r:i?n(t):"Object"==(s=n(t))&&"function"==typeof t.callee?"Arguments":s}},{"./$.cof":74,"./$.wks":115}],74:[function(e,t,r){var n={}.toString;t.exports=function(e){return n.call(e).slice(8,-1)}},{}],75:[function(e,t,r){"use strict";var n=e("./$"),a=e("./$.hide"),i=e("./$.redefine-all"),s=e("./$.ctx"),o=e("./$.strict-new"),u=e("./$.defined"),l=e("./$.for-of"),c=e("./$.iter-define"),f=e("./$.iter-step"),d=e("./$.uid")("id"),h=e("./$.has"),p=e("./$.is-object"),v=e("./$.set-species"),y=e("./$.descriptors"),b=Object.isExtensible||p,g=y?"_s":"size",_=0,m=function(e,t){if(!p(e))return"symbol"==typeof e?e:("string"==typeof e?"S":"P")+e;if(!h(e,d)){if(!b(e))return"F";if(!t)return"E";a(e,d,++_)}return"O"+e[d]},O=function(e,t){var r,n=m(t);if("F"!==n)return e._i[n];for(r=e._f;r;r=r.n)if(r.k==t)return r;
};t.exports={getConstructor:function(e,t,r,a){var c=e(function(e,i){o(e,c,t),e._i=n.create(null),e._f=void 0,e._l=void 0,e[g]=0,void 0!=i&&l(i,r,e[a],e)});return i(c.prototype,{clear:function(){for(var e=this,t=e._i,r=e._f;r;r=r.n)r.r=!0,r.p&&(r.p=r.p.n=void 0),delete t[r.i];e._f=e._l=void 0,e[g]=0},"delete":function(e){var t=this,r=O(t,e);if(r){var n=r.n,a=r.p;delete t._i[r.i],r.r=!0,a&&(a.n=n),n&&(n.p=a),t._f==r&&(t._f=n),t._l==r&&(t._l=a),t[g]--}return!!r},forEach:function(e){for(var t,r=s(e,arguments.length>1?arguments[1]:void 0,3);t=t?t.n:this._f;)for(r(t.v,t.k,this);t&&t.r;)t=t.p},has:function(e){return!!O(this,e)}}),y&&n.setDesc(c.prototype,"size",{get:function(){return u(this[g])}}),c},def:function(e,t,r){var n,a,i=O(e,t);return i?i.v=r:(e._l=i={i:a=m(t,!0),k:t,v:r,p:n=e._l,n:void 0,r:!1},e._f||(e._f=i),n&&(n.n=i),e[g]++,"F"!==a&&(e._i[a]=i)),e},getEntry:O,setStrong:function(e,t,r){c(e,t,function(e,t){this._t=e,this._k=t,this._l=void 0},function(){for(var e=this,t=e._k,r=e._l;r&&r.r;)r=r.p;return e._t&&(e._l=r=r?r.n:e._t._f)?"keys"==t?f(0,r.k):"values"==t?f(0,r.v):f(0,[r.k,r.v]):(e._t=void 0,f(1))},r?"entries":"values",!r,!0),v(t)}}},{"./$":98,"./$.ctx":80,"./$.defined":81,"./$.descriptors":82,"./$.for-of":85,"./$.has":87,"./$.hide":88,"./$.is-object":92,"./$.iter-define":95,"./$.iter-step":96,"./$.redefine-all":102,"./$.set-species":105,"./$.strict-new":108,"./$.uid":114}],76:[function(e,t,r){var n=e("./$.for-of"),a=e("./$.classof");t.exports=function(e){return function(){if(a(this)!=e)throw TypeError(e+"#toJSON isn't generic");var t=[];return n(this,!1,t.push,t),t}}},{"./$.classof":73,"./$.for-of":85}],77:[function(e,t,r){"use strict";var n=e("./$.hide"),a=e("./$.redefine-all"),i=e("./$.an-object"),s=e("./$.is-object"),o=e("./$.strict-new"),u=e("./$.for-of"),l=e("./$.array-methods"),c=e("./$.has"),f=e("./$.uid")("weak"),d=Object.isExtensible||s,h=l(5),p=l(6),v=0,y=function(e){return e._l||(e._l=new b)},b=function(){this.a=[]},g=function(e,t){return h(e.a,function(e){return e[0]===t})};b.prototype={get:function(e){var t=g(this,e);if(t)return t[1]},has:function(e){return!!g(this,e)},set:function(e,t){var r=g(this,e);r?r[1]=t:this.a.push([e,t])},"delete":function(e){var t=p(this.a,function(t){return t[0]===e});return~t&&this.a.splice(t,1),!!~t}},t.exports={getConstructor:function(e,t,r,n){var i=e(function(e,a){o(e,i,t),e._i=v++,e._l=void 0,void 0!=a&&u(a,r,e[n],e)});return a(i.prototype,{"delete":function(e){return!!s(e)&&(d(e)?c(e,f)&&c(e[f],this._i)&&delete e[f][this._i]:y(this)["delete"](e))},has:function(e){return!!s(e)&&(d(e)?c(e,f)&&c(e[f],this._i):y(this).has(e))}}),i},def:function(e,t,r){return d(i(t))?(c(t,f)||n(t,f,{}),t[f][e._i]=r):y(e).set(t,r),e},frozenStore:y,WEAK:f}},{"./$.an-object":70,"./$.array-methods":71,"./$.for-of":85,"./$.has":87,"./$.hide":88,"./$.is-object":92,"./$.redefine-all":102,"./$.strict-new":108,"./$.uid":114}],78:[function(e,t,r){"use strict";var n=e("./$"),a=e("./$.global"),i=e("./$.export"),s=e("./$.fails"),o=e("./$.hide"),u=e("./$.redefine-all"),l=e("./$.for-of"),c=e("./$.strict-new"),f=e("./$.is-object"),d=e("./$.set-to-string-tag"),h=e("./$.descriptors");t.exports=function(e,t,r,p,v,y){var b=a[e],g=b,_=v?"set":"add",m=g&&g.prototype,O={};return h&&"function"==typeof g&&(y||m.forEach&&!s(function(){(new g).entries().next()}))?(g=t(function(t,r){c(t,g,e),t._c=new b,void 0!=r&&l(r,v,t[_],t)}),n.each.call("add,clear,delete,forEach,get,has,set,keys,values,entries".split(","),function(e){var t="add"==e||"set"==e;e in m&&(!y||"clear"!=e)&&o(g.prototype,e,function(r,n){if(!t&&y&&!f(r))return"get"==e&&void 0;var a=this._c[e](0===r?0:r,n);return t?this:a})}),"size"in m&&n.setDesc(g.prototype,"size",{get:function(){return this._c.size}})):(g=p.getConstructor(t,e,v,_),u(g.prototype,r)),d(g,e),O[e]=g,i(i.G+i.W+i.F,O),y||p.setStrong(g,e,v),g}},{"./$":98,"./$.descriptors":82,"./$.export":83,"./$.fails":84,"./$.for-of":85,"./$.global":86,"./$.hide":88,"./$.is-object":92,"./$.redefine-all":102,"./$.set-to-string-tag":106,"./$.strict-new":108}],79:[function(e,t,r){var n=t.exports={version:"1.2.6"};"number"==typeof __e&&(__e=n)},{}],80:[function(e,t,r){var n=e("./$.a-function");t.exports=function(e,t,r){if(n(e),void 0===t)return e;switch(r){case 1:return function(r){return e.call(t,r)};case 2:return function(r,n){return e.call(t,r,n)};case 3:return function(r,n,a){return e.call(t,r,n,a)}}return function(){return e.apply(t,arguments)}}},{"./$.a-function":68}],81:[function(e,t,r){t.exports=function(e){if(void 0==e)throw TypeError("Can't call method on  "+e);return e}},{}],82:[function(e,t,r){t.exports=!e("./$.fails")(function(){return 7!=Object.defineProperty({},"a",{get:function(){return 7}}).a})},{"./$.fails":84}],83:[function(e,t,r){var n=e("./$.global"),a=e("./$.core"),i=e("./$.ctx"),s="prototype",o=function(e,t,r){var u,l,c,f=e&o.F,d=e&o.G,h=e&o.S,p=e&o.P,v=e&o.B,y=e&o.W,b=d?a:a[t]||(a[t]={}),g=d?n:h?n[t]:(n[t]||{})[s];d&&(r=t);for(u in r)l=!f&&g&&u in g,l&&u in b||(c=l?g[u]:r[u],b[u]=d&&"function"!=typeof g[u]?r[u]:v&&l?i(c,n):y&&g[u]==c?function(e){var t=function(t){return this instanceof e?new e(t):e(t)};return t[s]=e[s],t}(c):p&&"function"==typeof c?i(Function.call,c):c,p&&((b[s]||(b[s]={}))[u]=c))};o.F=1,o.G=2,o.S=4,o.P=8,o.B=16,o.W=32,t.exports=o},{"./$.core":79,"./$.ctx":80,"./$.global":86}],84:[function(e,t,r){t.exports=function(e){try{return!!e()}catch(t){return!0}}},{}],85:[function(e,t,r){var n=e("./$.ctx"),a=e("./$.iter-call"),i=e("./$.is-array-iter"),s=e("./$.an-object"),o=e("./$.to-length"),u=e("./core.get-iterator-method");t.exports=function(e,t,r,l){var c,f,d,h=u(e),p=n(r,l,t?2:1),v=0;if("function"!=typeof h)throw TypeError(e+" is not iterable!");if(i(h))for(c=o(e.length);c>v;v++)t?p(s(f=e[v])[0],f[1]):p(e[v]);else for(d=h.call(e);!(f=d.next()).done;)a(d,p,f.value,t)}},{"./$.an-object":70,"./$.ctx":80,"./$.is-array-iter":90,"./$.iter-call":93,"./$.to-length":112,"./core.get-iterator-method":116}],86:[function(e,t,r){var n=t.exports="undefined"!=typeof window&&window.Math==Math?window:"undefined"!=typeof self&&self.Math==Math?self:Function("return this")();"number"==typeof __g&&(__g=n)},{}],87:[function(e,t,r){var n={}.hasOwnProperty;t.exports=function(e,t){return n.call(e,t)}},{}],88:[function(e,t,r){var n=e("./$"),a=e("./$.property-desc");t.exports=e("./$.descriptors")?function(e,t,r){return n.setDesc(e,t,a(1,r))}:function(e,t,r){return e[t]=r,e}},{"./$":98,"./$.descriptors":82,"./$.property-desc":101}],89:[function(e,t,r){var n=e("./$.cof");t.exports=Object("z").propertyIsEnumerable(0)?Object:function(e){return"String"==n(e)?e.split(""):Object(e)}},{"./$.cof":74}],90:[function(e,t,r){var n=e("./$.iterators"),a=e("./$.wks")("iterator"),i=Array.prototype;t.exports=function(e){return void 0!==e&&(n.Array===e||i[a]===e)}},{"./$.iterators":97,"./$.wks":115}],91:[function(e,t,r){var n=e("./$.cof");t.exports=Array.isArray||function(e){return"Array"==n(e)}},{"./$.cof":74}],92:[function(e,t,r){t.exports=function(e){return"object"==typeof e?null!==e:"function"==typeof e}},{}],93:[function(e,t,r){var n=e("./$.an-object");t.exports=function(e,t,r,a){try{return a?t(n(r)[0],r[1]):t(r)}catch(i){var s=e["return"];throw void 0!==s&&n(s.call(e)),i}}},{"./$.an-object":70}],94:[function(e,t,r){"use strict";var n=e("./$"),a=e("./$.property-desc"),i=e("./$.set-to-string-tag"),s={};e("./$.hide")(s,e("./$.wks")("iterator"),function(){return this}),t.exports=function(e,t,r){e.prototype=n.create(s,{next:a(1,r)}),i(e,t+" Iterator")}},{"./$":98,"./$.hide":88,"./$.property-desc":101,"./$.set-to-string-tag":106,"./$.wks":115}],95:[function(e,t,r){"use strict";var n=e("./$.library"),a=e("./$.export"),i=e("./$.redefine"),s=e("./$.hide"),o=e("./$.has"),u=e("./$.iterators"),l=e("./$.iter-create"),c=e("./$.set-to-string-tag"),f=e("./$").getProto,d=e("./$.wks")("iterator"),h=!([].keys&&"next"in[].keys()),p="@@iterator",v="keys",y="values",b=function(){return this};t.exports=function(e,t,r,g,_,m,O){l(r,t,g);var C,k,w=function(e){if(!h&&e in j)return j[e];switch(e){case v:return function(){return new r(this,e)};case y:return function(){return new r(this,e)}}return function(){return new r(this,e)}},S=t+" Iterator",E=_==y,P=!1,j=e.prototype,A=j[d]||j[p]||_&&j[_],I=A||w(_);if(A){var T=f(I.call(new e));c(T,S,!0),!n&&o(j,p)&&s(T,d,b),E&&A.name!==y&&(P=!0,I=function(){return A.call(this)})}if(n&&!O||!h&&!P&&j[d]||s(j,d,I),u[t]=I,u[S]=b,_)if(C={values:E?I:w(y),keys:m?I:w(v),entries:E?w("entries"):I},O)for(k in C)k in j||i(j,k,C[k]);else a(a.P+a.F*(h||P),t,C);return C}},{"./$":98,"./$.export":83,"./$.has":87,"./$.hide":88,"./$.iter-create":94,"./$.iterators":97,"./$.library":99,"./$.redefine":103,"./$.set-to-string-tag":106,"./$.wks":115}],96:[function(e,t,r){t.exports=function(e,t){return{value:t,done:!!e}}},{}],97:[function(e,t,r){t.exports={}},{}],98:[function(e,t,r){var n=Object;t.exports={create:n.create,getProto:n.getPrototypeOf,isEnum:{}.propertyIsEnumerable,getDesc:n.getOwnPropertyDescriptor,setDesc:n.defineProperty,setDescs:n.defineProperties,getKeys:n.keys,getNames:n.getOwnPropertyNames,getSymbols:n.getOwnPropertySymbols,each:[].forEach}},{}],99:[function(e,t,r){t.exports=!0},{}],100:[function(e,t,r){var n=e("./$.export"),a=e("./$.core"),i=e("./$.fails");t.exports=function(e,t){var r=(a.Object||{})[e]||Object[e],s={};s[e]=t(r),n(n.S+n.F*i(function(){r(1)}),"Object",s)}},{"./$.core":79,"./$.export":83,"./$.fails":84}],101:[function(e,t,r){t.exports=function(e,t){return{enumerable:!(1&e),configurable:!(2&e),writable:!(4&e),value:t}}},{}],102:[function(e,t,r){var n=e("./$.redefine");t.exports=function(e,t){for(var r in t)n(e,r,t[r]);return e}},{"./$.redefine":103}],103:[function(e,t,r){t.exports=e("./$.hide")},{"./$.hide":88}],104:[function(e,t,r){var n=e("./$").getDesc,a=e("./$.is-object"),i=e("./$.an-object"),s=function(e,t){if(i(e),!a(t)&&null!==t)throw TypeError(t+": can't set as prototype!")};t.exports={set:Object.setPrototypeOf||("__proto__"in{}?function(t,r,a){try{a=e("./$.ctx")(Function.call,n(Object.prototype,"__proto__").set,2),a(t,[]),r=!(t instanceof Array)}catch(i){r=!0}return function(e,t){return s(e,t),r?e.__proto__=t:a(e,t),e}}({},!1):void 0),check:s}},{"./$":98,"./$.an-object":70,"./$.ctx":80,"./$.is-object":92}],105:[function(e,t,r){"use strict";var n=e("./$.core"),a=e("./$"),i=e("./$.descriptors"),s=e("./$.wks")("species");t.exports=function(e){var t=n[e];i&&t&&!t[s]&&a.setDesc(t,s,{configurable:!0,get:function(){return this}})}},{"./$":98,"./$.core":79,"./$.descriptors":82,"./$.wks":115}],106:[function(e,t,r){var n=e("./$").setDesc,a=e("./$.has"),i=e("./$.wks")("toStringTag");t.exports=function(e,t,r){e&&!a(e=r?e:e.prototype,i)&&n(e,i,{configurable:!0,value:t})}},{"./$":98,"./$.has":87,"./$.wks":115}],107:[function(e,t,r){var n=e("./$.global"),a="__core-js_shared__",i=n[a]||(n[a]={});t.exports=function(e){return i[e]||(i[e]={})}},{"./$.global":86}],108:[function(e,t,r){t.exports=function(e,t,r){if(!(e instanceof t))throw TypeError(r+": use the 'new' operator!");return e}},{}],109:[function(e,t,r){var n=e("./$.to-integer"),a=e("./$.defined");t.exports=function(e){return function(t,r){var i,s,o=String(a(t)),u=n(r),l=o.length;return u<0||u>=l?e?"":void 0:(i=o.charCodeAt(u),i<55296||i>56319||u+1===l||(s=o.charCodeAt(u+1))<56320||s>57343?e?o.charAt(u):i:e?o.slice(u,u+2):(i-55296<<10)+(s-56320)+65536)}}},{"./$.defined":81,"./$.to-integer":110}],110:[function(e,t,r){var n=Math.ceil,a=Math.floor;t.exports=function(e){return isNaN(e=+e)?0:(e>0?a:n)(e)}},{}],111:[function(e,t,r){var n=e("./$.iobject"),a=e("./$.defined");t.exports=function(e){return n(a(e))}},{"./$.defined":81,"./$.iobject":89}],112:[function(e,t,r){var n=e("./$.to-integer"),a=Math.min;t.exports=function(e){return e>0?a(n(e),9007199254740991):0}},{"./$.to-integer":110}],113:[function(e,t,r){var n=e("./$.defined");t.exports=function(e){return Object(n(e))}},{"./$.defined":81}],114:[function(e,t,r){var n=0,a=Math.random();t.exports=function(e){return"Symbol(".concat(void 0===e?"":e,")_",(++n+a).toString(36))}},{}],115:[function(e,t,r){var n=e("./$.shared")("wks"),a=e("./$.uid"),i=e("./$.global").Symbol;t.exports=function(e){return n[e]||(n[e]=i&&i[e]||(i||a)("Symbol."+e))}},{"./$.global":86,"./$.shared":107,"./$.uid":114}],116:[function(e,t,r){var n=e("./$.classof"),a=e("./$.wks")("iterator"),i=e("./$.iterators");t.exports=e("./$.core").getIteratorMethod=function(e){if(void 0!=e)return e[a]||e["@@iterator"]||i[n(e)]}},{"./$.classof":73,"./$.core":79,"./$.iterators":97,"./$.wks":115}],117:[function(e,t,r){var n=e("./$.an-object"),a=e("./core.get-iterator-method");t.exports=e("./$.core").getIterator=function(e){var t=a(e);if("function"!=typeof t)throw TypeError(e+" is not iterable!");return n(t.call(e))}},{"./$.an-object":70,"./$.core":79,"./core.get-iterator-method":116}],118:[function(e,t,r){"use strict";var n=e("./$.add-to-unscopables"),a=e("./$.iter-step"),i=e("./$.iterators"),s=e("./$.to-iobject");t.exports=e("./$.iter-define")(Array,"Array",function(e,t){this._t=s(e),this._i=0,this._k=t},function(){var e=this._t,t=this._k,r=this._i++;return!e||r>=e.length?(this._t=void 0,a(1)):"keys"==t?a(0,r):"values"==t?a(0,e[r]):a(0,[r,e[r]])},"values"),i.Arguments=i.Array,n("keys"),n("values"),n("entries")},{"./$.add-to-unscopables":69,"./$.iter-define":95,"./$.iter-step":96,"./$.iterators":97,"./$.to-iobject":111}],119:[function(e,t,r){"use strict";var n=e("./$.collection-strong");e("./$.collection")("Map",function(e){return function(){return e(this,arguments.length>0?arguments[0]:void 0)}},{get:function(e){var t=n.getEntry(this,e);return t&&t.v},set:function(e,t){return n.def(this,0===e?0:e,t)}},n,!0)},{"./$.collection":78,"./$.collection-strong":75}],120:[function(e,t,r){var n=e("./$.is-object");e("./$.object-sap")("freeze",function(e){return function(t){return e&&n(t)?e(t):t}})},{"./$.is-object":92,"./$.object-sap":100}],121:[function(e,t,r){var n=e("./$.to-iobject");e("./$.object-sap")("getOwnPropertyDescriptor",function(e){return function(t,r){return e(n(t),r)}})},{"./$.object-sap":100,"./$.to-iobject":111}],122:[function(e,t,r){var n=e("./$.to-object");e("./$.object-sap")("keys",function(e){return function(t){return e(n(t))}})},{"./$.object-sap":100,"./$.to-object":113}],123:[function(e,t,r){var n=e("./$.export");n(n.S,"Object",{setPrototypeOf:e("./$.set-proto").set})},{"./$.export":83,"./$.set-proto":104}],124:[function(e,t,r){arguments[4][58][0].apply(r,arguments)},{dup:58}],125:[function(e,t,r){"use strict";var n=e("./$.string-at")(!0);e("./$.iter-define")(String,"String",function(e){this._t=String(e),this._i=0},function(){var e,t=this._t,r=this._i;return r>=t.length?{value:void 0,done:!0}:(e=n(t,r),this._i+=e.length,{value:e,done:!1})})},{"./$.iter-define":95,"./$.string-at":109}],126:[function(e,t,r){"use strict";var n=e("./$"),a=e("./$.redefine"),i=e("./$.collection-weak"),s=e("./$.is-object"),o=e("./$.has"),u=i.frozenStore,l=i.WEAK,c=Object.isExtensible||s,f={},d=e("./$.collection")("WeakMap",function(e){return function(){return e(this,arguments.length>0?arguments[0]:void 0)}},{get:function(e){if(s(e)){if(!c(e))return u(this).get(e);if(o(e,l))return e[l][this._i]}},set:function(e,t){return i.def(this,e,t)}},i,!0,!0);7!=(new d).set((Object.freeze||Object)(f),7).get(f)&&n.each.call(["delete","has","get","set"],function(e){var t=d.prototype,r=t[e];a(t,e,function(t,n){if(s(t)&&!c(t)){var a=u(this)[e](t,n);return"set"==e?this:a}return r.call(this,t,n)})})},{"./$":98,"./$.collection":78,"./$.collection-weak":77,"./$.has":87,"./$.is-object":92,"./$.redefine":103}],127:[function(e,t,r){var n=e("./$.export");n(n.P,"Map",{toJSON:e("./$.collection-to-json")("Map")})},{"./$.collection-to-json":76,"./$.export":83}],128:[function(e,t,r){e("./es6.array.iterator");var n=e("./$.iterators");n.NodeList=n.HTMLCollection=n.Array},{"./$.iterators":97,"./es6.array.iterator":118}],129:[function(e,t,r){function n(){this._events=this._events||{},this._maxListeners=this._maxListeners||void 0}function a(e){return"function"==typeof e}function i(e){return"number"==typeof e}function s(e){return"object"==typeof e&&null!==e}function o(e){return void 0===e}t.exports=n,n.EventEmitter=n,n.prototype._events=void 0,n.prototype._maxListeners=void 0,n.defaultMaxListeners=10,n.prototype.setMaxListeners=function(e){if(!i(e)||e<0||isNaN(e))throw TypeError("n must be a positive number");return this._maxListeners=e,this},n.prototype.emit=function(e){var t,r,n,i,u,l;if(this._events||(this._events={}),"error"===e&&(!this._events.error||s(this._events.error)&&!this._events.error.length)){if(t=arguments[1],t instanceof Error)throw t;throw TypeError('Uncaught, unspecified "error" event.')}if(r=this._events[e],o(r))return!1;if(a(r))switch(arguments.length){case 1:r.call(this);break;case 2:r.call(this,arguments[1]);break;case 3:r.call(this,arguments[1],arguments[2]);break;default:for(n=arguments.length,i=new Array(n-1),u=1;u<n;u++)i[u-1]=arguments[u];r.apply(this,i)}else if(s(r)){for(n=arguments.length,i=new Array(n-1),u=1;u<n;u++)i[u-1]=arguments[u];for(l=r.slice(),n=l.length,u=0;u<n;u++)l[u].apply(this,i)}return!0},n.prototype.addListener=function(e,t){var r;if(!a(t))throw TypeError("listener must be a function");if(this._events||(this._events={}),this._events.newListener&&this.emit("newListener",e,a(t.listener)?t.listener:t),this._events[e]?s(this._events[e])?this._events[e].push(t):this._events[e]=[this._events[e],t]:this._events[e]=t,s(this._events[e])&&!this._events[e].warned){var r;r=o(this._maxListeners)?n.defaultMaxListeners:this._maxListeners,r&&r>0&&this._events[e].length>r&&(this._events[e].warned=!0,console.error("(node) warning: possible EventEmitter memory leak detected. %d listeners added. Use emitter.setMaxListeners() to increase limit.",this._events[e].length),"function"==typeof console.trace&&console.trace())}return this},n.prototype.on=n.prototype.addListener,n.prototype.once=function(e,t){function r(){this.removeListener(e,r),n||(n=!0,t.apply(this,arguments))}if(!a(t))throw TypeError("listener must be a function");var n=!1;return r.listener=t,this.on(e,r),this},n.prototype.removeListener=function(e,t){var r,n,i,o;if(!a(t))throw TypeError("listener must be a function");if(!this._events||!this._events[e])return this;if(r=this._events[e],i=r.length,n=-1,r===t||a(r.listener)&&r.listener===t)delete this._events[e],this._events.removeListener&&this.emit("removeListener",e,t);else if(s(r)){for(o=i;o-- >0;)if(r[o]===t||r[o].listener&&r[o].listener===t){n=o;break}if(n<0)return this;1===r.length?(r.length=0,delete this._events[e]):r.splice(n,1),this._events.removeListener&&this.emit("removeListener",e,t)}return this},n.prototype.removeAllListeners=function(e){var t,r;if(!this._events)return this;if(!this._events.removeListener)return 0===arguments.length?this._events={}:this._events[e]&&delete this._events[e],this;if(0===arguments.length){for(t in this._events)"removeListener"!==t&&this.removeAllListeners(t);return this.removeAllListeners("removeListener"),this._events={},this}if(r=this._events[e],a(r))this.removeListener(e,r);else for(;r.length;)this.removeListener(e,r[r.length-1]);return delete this._events[e],this},n.prototype.listeners=function(e){var t;return t=this._events&&this._events[e]?a(this._events[e])?[this._events[e]]:this._events[e].slice():[]},n.listenerCount=function(e,t){var r;return r=e._events&&e._events[t]?a(e._events[t])?1:e._events[t].length:0}},{}]},{},[10])(10)});